#include "Config.h"

#define SPELL_NONE -1
#define SPELL_SORCERER 0
#define SPELL_WIZARD 1
#define SPELL_CLERIC_DRUID 2
#define SPELL_BARDE 4
#define SPELL_PALADIN_RANGER 5
#define SPELL_ASSASIN_BLACKGUARD 7
#define SPELL_ADEPT	9
#define SPELL_HARPER 10

#define ATTACK_NONE 0
#define ATTACK_SINGLE_WEAPON 1
#define ATTACK_TWO_WEAPONS 2
#define ATTACK_BI_WEAPON 3
#define ATTACK_BOW 4
#define ATTACK_MONSTER 5

#define EFFECT_FIGHT 1
#define EFFECT_MAGIC 2
#define EFFECT_SHADOW 4
#define EFFECT_DIVINE 8

#define EQUIP_WEAPON 0
#define EQUIP_ARMOR 1
#define EQUIP_SHIELD 2
#define EQUIP_RING 3
#define EQUIP_AMULET 4
#define EQUIP_CLOAK 5
#define EQUIP_BOOTS 6
#define EQUIP_BELT 7
#define EQUIP_GLOVES 8
#define EQUIP_HELMET 9
#define EQUIP_MONEY 10
#define EQUIP_ARROWS 11
#define EQUIP_BRACERS 12
#define EQUIP_WESTMENT 13

#define SPECIAL_ARCANA 0
#define SPECIAL_SECRET 1
#define SPECIAL_ROGUE 2
#define SPECIAL_PSI_CRYSTAL 3
#define SPECIAL_PSI_COMBAT_MODE 4
#define SPECIAL_ANIMAL_TRICK 5
#define SPECIAL_MOUNT 6
#define SPECIAL_SERVANT 7
#define SPECIAL_HIEROPHANT 8

#define DEP_NONE 0
#define DEP_WEAPON 1
#define DEP_SPELL 2
#define DEP_SKILL 3
#define DEP_PSI 4

#define FEAT_TYPE_METAMAGIC 1
#define FEAT_TYPE_FIGHTER 2
#define FEAT_TYPE_PSIONIC 3
#define FEAT_TYPE_DIVINE 4

#define FEAT_TYPE_COUNT 5

#define WEAPON_SPECIAL_SWORD 1
#define WEAPON_SPECIAL_BOW 2
#define WEAPON_SPECIAL_ARMBRUST 3
#define WEAPON_SPECIAL_THROW 4

#define ATTRIBUTE_NAME_SHORT_BUFFER 3
#define ATTRIBUTE_COUNT 6

#define G_END 0
#define G_LINK 1
#define G_OPT 2
#define G_REP 3
#define G_GROUP 4
#define G_STRING 5
#define G_OR 6
#define G_NOT 7
#define G_SEP 8

#define ASCIIae 8 * 16 + 4
#define ASCIIAE 8 * 16 + 14
#define ASCIIoe 9 * 16 + 4
#define ASCIIOE 9 * 16 + 9
#define ASCIIue 8 * 16 + 1
#define ASCIIUE 9 * 16 + 10
#define ASCIIsz 14 * 16 + 1

#ifdef BUILD_32
#ifdef BUILD_64
#error Cannot build 32 AND 64 Bit versions together atm
#endif
#endif

#ifndef BUILD_32
#ifndef BUILD_64
#error You must enable 32 or 64 Bit compilation
#endif
#endif

#ifndef BUILD_DEBUG
#ifndef BUILD_INTEL
#ifndef BUILD_VECTORC
#ifndef BUILD_GCC
#ifndef BUILD_VS_NET
#error You must at least enable one Runtime! :|
#endif
#endif
#endif
#endif
#endif

#define RUNTIME_DEBUG 0
#define RUNTIME_INTEL 1
#define RUNTIME_VECTORC 2
#define RUNTIME_GCC 3
#define RUNTIME_VS 4

#ifndef MALLOC_LOG
#ifdef DEBUG_REBUILD
#define QON_MALLOC_NO_NEW_LOG
#define QON_ENABLE_LOG_STRING
#define QON_EXPORT_MALLOC_LOG
#endif
#endif

#ifdef DEBUG_REBUILD
#ifdef DEBUG_RUNTIME
#ifndef INCLUDE_REBUILD
#define INCLUDE_REBUILD
#endif
#ifndef MALLOC_LOG
#define MALLOC_LOG
#endif
#ifndef DUMP_SOURCE
#define DUMP_SOURCE
#endif
#ifdef STRING_KEEP_ALLOC
#undef STRING_KEEP_ALLOC
#endif
#ifndef ALLOW_TEST_SCRIPT
#define ALLOW_TEST_SCRIPT
#endif
#endif
#endif

#ifndef INCLUDE_REBUILD
	#ifdef DUMP_SOURCE
		#error Cannot Dump Source with Rebuild disabled
	#endif
	#ifndef DUMP_SOURCE_LOAD
		#error DUMP_SOURCE_LOAD must be enabled when Rebuild is disabled
	#endif
	#ifdef ALLOW_TEST_SCRIPT
		#error Testscript unavailable when Rebuild disabled
	#endif
#endif

#if DEBUG_ALLOC == 1
#define DEBUG_ALLOC_VERBOSE 0
#else
#define DEBUG_ALLOC_VERBOSE 3
#endif

#ifdef GCC_RUNTIME
	#define GNU_ASM
#endif

#ifndef MALLOC_LOG
	#undef DUMP_SOURCE
#endif

#ifdef DEBUG_SAVE
#ifdef DEBUG_RUNTIME
#define AUTO_SAVE
#endif
#endif

#ifndef CONFIGURING
#ifdef MALLOC_LOG
#ifndef QON_MALLOC_NO_NEW_LOG
	extern void* __cdecl operator new[] (size_t size);
	extern void* __cdecl operator new (size_t size);
	extern void __cdecl operator delete[] (void* pointer);
	extern void __cdecl operator delete (void* pointer);
#endif
#endif

extern "C" int __cdecl breakpoint(char* Text);
#endif

#ifdef BUILD_64
#define QON_DISABLE_QPRINTF
#ifdef USE_ASM
#undef USE_ASM
#endif
#ifdef BUILD_VECTORC
#undef BUILD_VECTORC
#endif
#ifdef BUILD_GCC
#undef BUILD_GCC
#endif
#endif

#pragma warning(disable : 4996)
#ifdef BUILD_64
#pragma warning(disable : 1786)
#endif
#define _CRT_SECURE_NO_WARNINGS