void SetMonsterSpellChar(clsChar* pChar)
{
	int i, j, k;
	char* pSpellChar;
	size_t pSpellCharLen;
	char* CharName;
	char* pCharName;
	int Level;

	if (Source.MonsterSource[pChar->MonsterName].SpellChar[0] != '0')
	{
		pChar->ClassCount = 0;
		pSpellChar = Source.MonsterSource[pChar->MonsterName].SpellChar;
		while (*pSpellChar)
		{
			CharName = (char*) mallocl(strlen(pSpellChar), "SetMonsterSpellChar-CharName");

			pSpellCharLen = strlen(pSpellChar);
			sscanf(pSpellChar, "%s %d", CharName, &Level);
			if (strstr(CharName, "|"))
			{
				i = 0;
				for (j = 0;j < (signed) strlen(CharName);j++)
				{
					if (CharName[j] == '|')
					{
						i++;
					}
				}
				k = random(pChar->Context.seeda, 0, i, "Welcher Spellchar");
				i = 0;
				for (j = 0;j < (signed) strlen(CharName);j++)
				{
					if (i == k)
					{
						pCharName = &CharName[j];
						str_replace('|', 0, pCharName);
						break;
					}
					if (CharName[j] == '|')
					{
						i++;
					}
				}
			}
			else
			{
				pCharName = CharName;
			}
			mCheckOverflow(pChar->ClassCount, MAX_CLASSES, "Class Array", "MAX_CLASSES");
			pChar->Classes[pChar->ClassCount] = GetCharNumber(pCharName);
			pChar->Levels[pChar->ClassCount] = Level;
			pChar->LevelsClassic[pChar->ClassCount] = min(20, Level);
			pChar->ClassCount++;
			pSpellChar += pSpellCharLen + 1;

			freel(CharName);
		}
		for (i = 0;i < pChar->ClassCount;i++)
		{
			pChar->DummyClass[i] = 1;
			pChar->DummyClassClericSpells[i] = Source.MonsterSource[pChar->MonsterName].ClericSpells;
		}
	}
}

void ChangeSizeDmg(int* dmg1, int* dmg2)
{
	if (*dmg2 == 2)
	{
		*dmg2 = 3;
	}
	else if (*dmg2 == 3)
	{
		*dmg2 = 4;
	}
	else if (*dmg2 == 4)
	{
		*dmg2 = 6;
	}
	else if (*dmg2 == 6)
	{
		*dmg2 = 8;
	}
	else if (*dmg2 == 8)
	{
		*dmg2 = 6;
		*dmg1 *= 2;
	}
	else if (*dmg2 == 10)
	{
		*dmg2 = 6;
		*dmg1 *= 2;
	}
	else if (*dmg2 == 12)
	{
		*dmg2 = 8;
		*dmg1 *= 2;
	}
}

void IncreaseMonsterAttributes(clsChar* pChar, int* NewAttributes, int Num = ATTRIBUTE_COUNT, int AttributeOnly = 0)
{
	int OldMods[ATTRIBUTE_COUNT];
	int i;

	CalcMods(pChar);
	CopyMemory(OldMods, pChar->Mods, 6 * sizeof(int));
	for (i = 0;i < Num;i++)
	{
		if (!pChar->IgnoreAttr[i]) pChar->Attributes[i] += NewAttributes[i];
	}
	CalcMods(pChar);

	if (AttributeOnly)
	{
		return;
	}

	pChar->AC += pChar->Mods[1] - OldMods[1];
	pChar->ACDex += pChar->Mods[1] - OldMods[1];

	pChar->RWRef += pChar->Mods[1] - OldMods[1];
	pChar->RWWil += pChar->Mods[4] - OldMods[4];
	pChar->RWZaeh += pChar->Mods[2] - OldMods[2];
	pChar->RWRefAttr += pChar->Mods[1] - OldMods[1];
	pChar->RWWilAttr += pChar->Mods[4] - OldMods[4];
	pChar->RWZaehAttr += pChar->Mods[2] - OldMods[2];

	pChar->Life += pChar->Level * (pChar->Mods[2] - OldMods[2]);

	pChar->GAMeleeAttr += pChar->Mods[0] - OldMods[0];
	pChar->GAShotAttr += pChar->Mods[1] - OldMods[1];

	for (i = 0;i < pChar->MAttackCount;i++)
	{
		pChar->MAttackBonus[i] += pChar->Mods[0] - OldMods[0];
		pChar->MDamageC[i] += pChar->Mods[0] - OldMods[0];
		ChangeSizeDmg(&pChar->MDamageA[i], &pChar->MDamageB[i]);
	}
}

void IncreaseSize(clsChar* pChar)
{
	int i;

	pChar->AC += Source.SizeSource[pChar->MSize].AC;
	pChar->AC += Source.SizeSource[pChar->MSize].SizeMod;
	for (i = 0;i < pChar->MAttackCount;i++)
	{
		pChar->MAttackBonus[i] += Source.SizeSource[pChar->MSize].SizeMod;
	}

	IncreaseMonsterAttributes(pChar, Source.SizeSource[pChar->MSize].Mods, 3);
	
	pChar->MSize++;
	pChar->MonsterSize++;
}

void GetMonsterGARW(clsChar* pChar, int* GA, int* RWRef, int* RWWil, int* RWZaeh)
{
	if (!pChar->Monster)
	{
		*GA = GetGA(pChar->MonsterLevel, 1);
		*RWRef = *RWWil = *RWZaeh = GetRW(pChar->MonsterLevel, 1);
		return;
	}
	else
	{
		*GA = GetGA(pChar->MonsterLevel, Source.MonsterTypeSource[pChar->MonsterType].GAType);
		*RWRef = GetRW(pChar->MonsterLevel, Source.MonsterTypeSource[pChar->MonsterType].RWRefType);
		*RWWil = GetRW(pChar->MonsterLevel, Source.MonsterTypeSource[pChar->MonsterType].RWWilType);
		*RWZaeh = GetRW(pChar->MonsterLevel, Source.MonsterTypeSource[pChar->MonsterType].RWZaehType);
	}
}

int CalcCRMod(int Level, int HD, int HDInc)
{
	double tmpval;
	tmpval = (double) Level / (double) GreaterZero(HD);
	tmpval = log(tmpval) / log((double) 2);
	tmpval = max(HDInc, (int) (tmpval * 4 + 0.5));
	tmpval = min(tmpval, GreaterZero(Level - HD));
	return((int) tmpval);
}

void SetMonster(clsChar* pChar)
{
	int i;
	int PosProb[32];
	int PosType;
	int OldGA, NewGA;
	int OldRWRef, NewRWRef;
	int OldRWWil, NewRWWil;
	int OldRWZaeh, NewRWZaeh;
	int OldType, NewType;

	int a, temp2;

	if (RandomText) sprintf(pChar->Context.tempout, "Template whlen!\n");
	for (i = 0;i < pChar->CRPosCount;i++)
	{
		if (RandomText)
		{
			sprintf(pChar->Context.tempstring, "%d: Template: %s, TW Erhhung: %d\n", i, Source.TemplateSource[pChar->CRPosTemplate[i]].Name.buffer, pChar->CRPosHD[i]);
			strcat(pChar->Context.tempout, pChar->Context.tempstring);
		}
		PosProb[i] = 1;
		if (pChar->CRPosTemplate[i] == 0)
		{
			PosProb[i] += 15;
		}
		if (pChar->CRPosHD[i] == 0)
		{
			PosProb[i] += 5;
		}
	}
	PosType = AdvancedRand(pChar->Context.seeda, pChar->CRPosCount, PosProb, sizeof(int), "", 0, pChar->Context.tempout, ChooseClass);

	sprintf(pChar->Context.tempout, "Template: %s, Bonus TW Level: %d\n", Source.TemplateSource[pChar->CRPosTemplate[PosType]].Name.buffer, pChar->CRPosHD[PosType]);
	pChar->strings.CharText += pChar->Context.tempout;

	pChar->MonsterTWType = Source.MonsterSource[pChar->MonsterName].HDType;
	pChar->MonsterSize = Source.MonsterSource[pChar->MonsterName].Size;
	pChar->MonsterType = Source.MonsterSource[pChar->MonsterName].Type;
	OldType = pChar->MonsterType;
	pChar->ClassCount = 0;
	pChar->Level = pChar->MonsterLevel = Source.MonsterSource[pChar->MonsterName].HD;

	GetMonsterGARW(pChar, &OldGA, &OldRWRef, &OldRWWil, &OldRWZaeh);

	pChar->strings.CharText += Source.TemplateSource[pChar->CRPosTemplate[PosType]].TemplateDesc;

	mGetStatic(sisave_SM_TCe, sbsave_SM_TCe, GetTemplateNumber("Celestial"));
	mGetStatic(sisave_SM_TFi, sbsave_SM_TFi, GetTemplateNumber("Fiendish"));
	if (pChar->CRPosTemplate[PosType] == sisave_SM_TCe || pChar->CRPosTemplate[PosType] == sisave_SM_TFi)
	{
		mGetStatic(sisave_SM_Be, sbsave_SM_Be, GetMonsterTypeNumber("Beast"));
		mGetStatic(sisave_SM_An, sbsave_SM_An, GetMonsterTypeNumber("Animal"));
		mGetStatic(sisave_SM_MaBe, sbsave_SM_MaBe, GetMonsterTypeNumber("MagicalBeast"));
		if (pChar->MonsterType == sisave_SM_Be || pChar->MonsterType == sisave_SM_An)
		{
			pChar->MonsterType = sisave_SM_MaBe;
		}
	}

	if (Source.TemplateSource[pChar->CRPosTemplate[PosType]].NewType.buffer[0] != ';')
	{
		pChar->MonsterType = GetMonsterTypeNumber(Source.TemplateSource[pChar->CRPosTemplate[PosType]].NewType.buffer);
	}
	
	CopyMemory(pChar->Attributes, Source.MonsterSource[pChar->MonsterName].Attr, ATTRIBUTE_COUNT * sizeof(int));
	for (i = 0;i < ATTRIBUTE_COUNT;i++) if (pChar->Attributes[i] == 0) pChar->IgnoreAttr[i] = 1;
	CalcMods(pChar);
	
	pChar->Initiative = Source.MonsterSource[pChar->MonsterName].Init;
	pChar->InitiativeDex = pChar->Mods[1];
	pChar->InitiativeRest = 0;
	
	pChar->AC = Source.MonsterSource[pChar->MonsterName].AC;

	pChar->RWRef = Source.MonsterSource[pChar->MonsterName].RWRef;
	pChar->RWWil = Source.MonsterSource[pChar->MonsterName].RWWil;
	pChar->RWZaeh = Source.MonsterSource[pChar->MonsterName].RWZaeh;

	temp2 = Source.Treasure[pChar->HG + pChar->MixedHG] * Source.MonsterSource[pChar->MonsterName].Treasure;
	if (temp2 == 0 && pChar->MixedHG)
	{
		temp2 = Source.Treasure[pChar->MixedHG];
	}

	pChar->Money = random(pChar->Context.seeda, 75, 175, "Geldwert in %%") * temp2 / 100;
	pChar->MoneyRest = pChar->Money;
	pChar->Treasure = pChar->Money;
	pChar->TreasureLeft = pChar->Money;

	pChar->Range = (float) ((double) Source.MonsterSource[pChar->MonsterName].Speed / (double) 10 * (double) 3);

	pChar->AttackType[0] = ATTACK_MONSTER;
	pChar->AttackType[1] = ATTACK_NONE;

	mGetStatic(sisave_SM_Dr, sbsave_SM_Dr, GetMonsterTypeNumber("Dragon"));
	if (Source.MonsterSource[pChar->MonsterName].Type == sisave_SM_Dr &&
		Source.MonsterSource[pChar->MonsterName].FeatCount == 0)
	{
		int* PMod;
		pChar->FeatCount = Source.MonsterSource[pChar->MonsterName].HD / 4;
		pChar->SkillCountReal = (Source.MonsterSource[pChar->MonsterName].HD + 3) * (6 + Source.MonsterSource[pChar->MonsterName].Attr[3]);

		PMod = pChar->Context.TempProb;
		ZeroMemory(PMod, Source.FeatSourceCount * sizeof(int));

		mGetStatic(sisave_SM_Kae, sbsave_SM_Kae, GetCharNumber("Kmpfer"));
		mGetStatic(sisave_SM_He, sbsave_SM_He, GetCharNumber("Hexenmeister"));
		mGetStatic(sisave_SM_Ma, sbsave_SM_Ma, GetCharNumber("Magier"));
		i = 0;
		pChar->ClassCount = 1;
		pChar->Classes[0] = sisave_SM_Kae;
		pChar->FeatCount /= 2;
		pChar->Levels[0] = 20;
		DoFeats(pChar, PMod, sisave_SM_Kae, false, &i, Source.MonsterSource[pChar->MonsterName].Epic);

		pChar->Classes[0] = sisave_SM_He;
		i = pChar->FeatCount;
		pChar->FeatCount *= 2;
		DoFeats(pChar, PMod, sisave_SM_Ma, false, &i, Source.MonsterSource[pChar->MonsterName].Epic);
		pChar->ClassCount = 0;
		CalculateSkills(pChar, 1);

		for (i = 0;i < pChar->FeatCount;i++)
		{
			pChar->FeatDone[i] = 1;
			if (Source.FeatSource[pChar->Feats[i]].DepType == DEP_WEAPON && pChar->FeatDependancy[i] >= 0)
			{
				mGetStatic(sisave_SM_Kla, sbsave_SM_Kla, GetEquipNumber("Klaue"));
				pChar->FeatDependancy[i] = sisave_SM_Kla;
				pChar->FeatDone[i] = 0;
			}
		}
	}
	else
	{
		for (i = 0;i < Source.MonsterSource[pChar->MonsterName].FeatCount;i++)
		{
			pChar->Feats[i] = Source.MonsterSource[pChar->MonsterName].Feats[i];
			pChar->FeatDone[i] = 1;
			pChar->FeatDependancy[i] = -2;
		}
		pChar->FeatCount = Source.MonsterSource[pChar->MonsterName].FeatCount;

		for (i = 0;i < Source.MonsterSource[pChar->MonsterName].SkillCount;i++)
		{
			pChar->Skills[i] = Source.MonsterSource[pChar->MonsterName].Skills[i];
			pChar->SkillRank[i] = Source.MonsterSource[pChar->MonsterName].SkillLevels[i];
		}
		pChar->SkillCountReal = 0;
		pChar->SkillCount = Source.MonsterSource[pChar->MonsterName].SkillCount;
	}

	for (i = 0;i < Source.MonsterSource[pChar->MonsterName].AttackCount;i++)
	{
		pChar->MAttackBonus[i] = Source.MonsterSource[pChar->MonsterName].AttackBonus[i];
		pChar->MAttackNumber[i] = Source.MonsterSource[pChar->MonsterName].AttackNumber[i];
		pChar->MAttackRed[i] = Source.MonsterSource[pChar->MonsterName].AttackRed[i];
		pChar->MDamageA[i] = Source.MonsterSource[pChar->MonsterName].DamageA[i];
		pChar->MDamageB[i] = Source.MonsterSource[pChar->MonsterName].DamageB[i];
		pChar->MDamageC[i] = Source.MonsterSource[pChar->MonsterName].DamageC[i];
		pChar->MAlternateAttack[i] = Source.MonsterSource[pChar->MonsterName].AlternateAttack[i];
		pChar->strings.MAttackType[i] = Source.MonsterSource[pChar->MonsterName].AttackType[i];
	}
	pChar->MAttackCount = Source.MonsterSource[pChar->MonsterName].AttackCount;

	pChar->MSize = Source.MonsterSource[pChar->MonsterName].Size;

	pChar->Life = Source.MonsterSource[pChar->MonsterName].TPBonus;

	if (pChar->CreationTemplate->MonsterName != -1 && pChar->CreationTemplate->MonsterNameHD)
	{
		pChar->Level = pChar->MonsterLevel = pChar->CreationTemplate->MonsterNameHD;
	}
	else
	{
		int tmpminlvl, tmpmaxlvl;
		double basecradd;

		if (pChar->CRPosHD[PosType] == 0)
		{
			tmpminlvl = tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HD;
		}
		else if (pChar->CRPosHD[PosType] == 1)
		{
			if (Source.MonsterSource[pChar->MonsterName].HDInc > 0)
			{
				tmpminlvl = Source.MonsterSource[pChar->MonsterName].HDMin;
				tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HDInc - 1;
			}
			else
			{
				tmpminlvl = Source.MonsterSource[pChar->MonsterName].HDMin;
				tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HDMax;
			}
		}
		else if (pChar->CRPosHD[PosType] == 2)
		{
			if (Source.MonsterSource[pChar->MonsterName].HDInc2 > 0)
			{
				tmpminlvl = Source.MonsterSource[pChar->MonsterName].HDInc;
				tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HDInc2 - 1;
			}
			else
			{
				tmpminlvl = Source.MonsterSource[pChar->MonsterName].HDInc;
				tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HDMax;
			}
		}
		else if (pChar->CRPosHD[PosType] == 3)
		{
			tmpminlvl = Source.MonsterSource[pChar->MonsterName].HDInc2;
			tmpmaxlvl = Source.MonsterSource[pChar->MonsterName].HDMax;
		}
		basecradd = CalcCRMod(tmpminlvl, Source.MonsterSource[pChar->MonsterName].HD, pChar->CRPosHD[PosType]);

		do
		{
			pChar->Level = pChar->MonsterLevel = random(pChar->Context.seeda, tmpminlvl, tmpmaxlvl, "Trefferwrfel");

			a = CalcCRMod(pChar->MonsterLevel, Source.MonsterSource[pChar->MonsterName].HD, pChar->CRPosHD[PosType]);
			a += pChar->CRPosCR[PosType] - (int) basecradd;

			if (a > pChar->HG)
			{
				tmpmaxlvl--;
			}
			else if (a < pChar->HG)
			{
				tmpminlvl++;
			}
		} while (a != pChar->HG);
	}

	if (pChar->MonsterLevel != Source.MonsterSource[pChar->MonsterName].HD)
	{
		IncreaseHDFeatSkill(pChar, Source.MonsterSource[pChar->MonsterName].HD, pChar->MonsterLevel, Source.MonsterTypeSource[Source.MonsterSource[pChar->MonsterName].Type].Skills, Source.MonsterTypeSource[Source.MonsterSource[pChar->MonsterName].Type].Feats);
	}

	if (pChar->MonsterLevel >= Source.MonsterSource[pChar->MonsterName].HDInc && Source.MonsterSource[pChar->MonsterName].HDInc > 0)
	{
		IncreaseSize(pChar);
	}

	if (pChar->MonsterLevel >= Source.MonsterSource[pChar->MonsterName].HDInc2 && Source.MonsterSource[pChar->MonsterName].HDInc2 > 0)
	{
		IncreaseSize(pChar);
	}
	
	for (i = 0;i < pChar->MonsterLevel;i++)
	{
		pChar->Life += random(pChar->Context.seeda, 1, pChar->MonsterTWType, "Trefferwrfel");
	}

	if (Source.TemplateSource[pChar->CRPosTemplate[PosType]].NewType == "Undead")
	{
		pChar->IgnoreAttr[2] = 1;
		pChar->Attributes[2] = 0;
		pChar->Life = max(pChar->Level, pChar->Life - pChar->Level * pChar->Mods[2]);
		pChar->RWZaeh -= pChar->Mods[2];
		pChar->Mods[2] = 0;
	}

	IncreaseMonsterAttributes(pChar, Source.TemplateSource[pChar->CRPosTemplate[PosType]].AttributeMod);

	mGetStatic(sisave_SM_TK, sbsave_SM_TK, GetTemplateNumber("Keins"));
	if (pChar->CRPosTemplate[PosType] != sisave_SM_TK)
	{
		RunScript(pChar, NULL, &pChar->strings.CharText, Source.TemplateSource[pChar->CRPosTemplate[PosType]].Script, Source.TemplateSource[pChar->CRPosTemplate[PosType]].Name);
	}

	mGetStatic(sisave_SM_TSk, sbsave_SM_TSk, GetTemplateNumber("Skelleton"));
	if (pChar->CRPosTemplate[PosType] == sisave_SM_TSk)
	{
		pChar->MAttackCount = 1;
		pChar->MAttackBonus[0] = pChar->MonsterLevel / 2 + pChar->Mods[1];
		pChar->MDamageA[0] = 1;
		pChar->MDamageB[0] = 4;
		for (i = GetSizeNumber("Medium");i < pChar->MSize;i++)
		{
			ChangeSizeDmg(&pChar->MDamageA[0], &pChar->MDamageB[0]);
		}
		pChar->MDamageC[0] = pChar->Mods[0];
		pChar->strings.MAttackType[0] = "Klaue";
		pChar->MAttackNumber[0] = 2;
		pChar->MAttackRed[0] = 0;
		pChar->SkillCount = 0;
		pChar->FeatCount = 1;
		mGetStatic(sisave_SM_VI, sbsave_SM_VI, GetFeatNumber("VerbesserteInitiative"));
		pChar->Feats[0] = sisave_SM_VI;
	}

	CalcMods(pChar);
	if (!(pChar->CRPosTemplate[PosType] == sisave_SM_TSk))
	{
		pChar->strings.CharText += Source.MonsterSource[pChar->MonsterName].MonsterDesc;
		SetMonsterSpellChar(pChar);
		pChar->MR = max(pChar->MR, Source.MonsterSource[pChar->MonsterName].MR);
		for (i = 1;i <= *Source.MonsterSource[pChar->MonsterName].AbbilityCode.ptr;i++)
		{
			pChar->strings.CharText += Source.AbbilitySource[Source.MonsterSource[pChar->MonsterName].AbbilityCode[i]].Text;
			pChar->strings.CharText += "\n";
			RunScript(pChar, NULL, &pChar->strings.CharText, Source.AbbilitySource[Source.MonsterSource[pChar->MonsterName].AbbilityCode[i]].Script, Source.AbbilitySource[Source.MonsterSource[pChar->MonsterName].AbbilityCode[i]].Name);
		}
	}

	NewType = pChar->MonsterType;
	GetMonsterGARW(pChar, &NewGA, &NewRWRef, &NewRWWil, &NewRWZaeh);
	pChar->MonsterType = NewType;

	pChar->GAMeleeAttr = pChar->Mods[0];
	pChar->GAShotAttr = pChar->Mods[1];
	pChar->GASize = -pChar->MSize + 4;
	if (pChar->GASize == -5) {pChar->GASize++;}
	if (abs(pChar->GASize) == 3) {pChar->GASize = (pChar->GASize * 4) / 3;}
	if (abs(pChar->GASize) == 4) {pChar->GASize = (pChar->GASize * 2);}
	pChar->GAEpic = 0;
	pChar->GAMeleeRest = 0;
	pChar->GAShotRest = 0;
	pChar->GA = NewGA;
	pChar->GAMelee = pChar->GA + pChar->GAMeleeAttr + pChar->GAMeleeRest + pChar->GASize;
	pChar->GAShot = pChar->GA + pChar->GAShotAttr + pChar->GAShotRest + pChar->GASize;

	pChar->RWRefBase = NewRWRef;
	pChar->RWWilBase = NewRWWil;
	pChar->RWZaehBase = NewRWZaeh;

	pChar->RWRefAttr = pChar->Mods[1];
	pChar->RWWilAttr = pChar->Mods[4];
	pChar->RWZaehAttr = pChar->Mods[2];
	
	NewGA -= OldGA;
	NewRWRef -= OldRWRef;
	NewRWWil -= OldRWWil;
	NewRWZaeh -= OldRWZaeh;

	pChar->RWRef += NewRWRef;
	pChar->RWWil += NewRWWil;
	pChar->RWZaeh += NewRWZaeh;

	for (i = 0;i < pChar->MAttackCount;i++)
	{
		pChar->MAttackBonus[i] += NewGA;
	}

	pChar->ACSize = pChar->GASize;
	pChar->ACDex = pChar->Mods[1];
}

int DetermineCRA(int Monster, int HDInc, int Template, int* CRSpace, int Mixed = 0)
{
	int CurCR;
	char* CheckPos;
	int i;
	int Missed;
	
	CurCR = Source.MonsterSource[Monster].CR;

	for (i = 0;i < 2;i++)
	{
		CheckPos = Source.TemplateSource[Template].ForbitType.buffer;
		if (i == 1)
		{
			CheckPos = Source.TemplateSource[Template].ForceType.buffer;
		}
		if (*CheckPos)
		{
			Missed = i;
			while (*CheckPos)
			{
				if (GetMonsterTypeNumber(CheckPos) == Source.MonsterSource[Monster].Type)
				{
					Missed ^= 1;
					break;
				}
				CheckPos += strlen(CheckPos) + 1;
			}
			if (Missed)
			{
				CurCR += 1024;
				break;
			}
		}
	}
	
	if (Mixed && Source.MonsterTypeSource[Source.MonsterSource[Monster].Type].Mixed == 0)
	{
		CurCR += 1024;
	}

	if (Mixed && Source.TemplateSource[Template].Mixed == 0)
	{
		CurCR += 1024;
	}
	mGetStatic(sisave_DCRA_TSk, sbsave_DCRA_TSk, GetTemplateNumber("Skelleton"));
	if (Template == sisave_DCRA_TSk && strncmp(Source.MonsterSource[Monster].Name, "Hydra", 5) == 0)
	{
		CurCR += 1024;
	}
	
	if (CurCR < 1024)
	{
		clsChar CRTempChar;

		CopyMemory(CRTempChar.Attributes, Source.MonsterSource[Monster].Attr, ATTRIBUTE_COUNT * sizeof(int));
		CRTempChar.Context.FetchVarCounter[0] = CurCR;
		CRTempChar.Context.FetchVarCounter[1] = Source.MonsterSource[Monster].HD;
		RunScript(&CRTempChar, NULL, NULL, Source.TemplateSource[Template].CRScript, Source.TemplateSource[Template].Name);
		CurCR = CRTempChar.Context.FetchVarCounter[0];
	}

	int NewHDMin;
	int NewHDMax;
	NewHDMin = Source.MonsterSource[Monster].HD;
	NewHDMax = Source.MonsterSource[Monster].HD;
	switch (HDInc)
	{
	case 0:
		break;
	case 1:
		if (!(Source.MonsterSource[Monster].HDMin > 0)) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDMin == Source.MonsterSource[Monster].HDInc) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc > 0)
		{
			NewHDMin = Source.MonsterSource[Monster].HDMin;
			NewHDMax = Source.MonsterSource[Monster].HDInc - 1;
		}
		else
		{
			NewHDMin = Source.MonsterSource[Monster].HDMin;
			NewHDMax = Source.MonsterSource[Monster].HDMax;
		}
		break;
	case 2:
		if (!(Source.MonsterSource[Monster].HDInc > 0)) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc == Source.MonsterSource[Monster].HDInc2) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc2 > 0)
		{
			NewHDMin = Source.MonsterSource[Monster].HDInc;
			NewHDMax = Source.MonsterSource[Monster].HDInc2 - 1;
		}
		else
		{
			NewHDMin = Source.MonsterSource[Monster].HDInc;
			NewHDMax = Source.MonsterSource[Monster].HDMax;
		}
		break;
	case 3:
		if (!(Source.MonsterSource[Monster].HDInc2 > 0)) {CurCR += 1024;}
		NewHDMin = Source.MonsterSource[Monster].HDInc2;
		NewHDMax = Source.MonsterSource[Monster].HDMax;
		break;
	}

	*CRSpace = CurCR + CalcCRMod(NewHDMax, Source.MonsterSource[Monster].HD, HDInc);
	CurCR += CalcCRMod(NewHDMin, Source.MonsterSource[Monster].HD, HDInc);

	return(CurCR);
}

int DetermineCR(int Monster, int HDInc, int Template, int* CRSpace, int Mixed, int Init)
{
	int i, j, k;
	int CurCR;

	if (Init)
	{
		Source.MonsterCR = (int*) mallocl(Source.MonsterSourceCount * Source.TemplateSourceCount * 4 * 2 * sizeof(int), "DetermineCR-MonsterCR");
		for (i = 0;i < Source.MonsterSourceCount;i++)
		{
			for (j = 0;j < Source.TemplateSourceCount;j++)
			{
				for (k = 0;k < 4;k++)
				{
					Source.MonsterCR[(i * Source.TemplateSourceCount * 4 + j * 4 + k) * 2] =
						DetermineCRA(i, k, j, &Source.MonsterCR[(i * Source.TemplateSourceCount * 4 + j * 4 + k) * 2 + 1]);
				}
			}
		}
		return(0);
	}

	CurCR = Source.MonsterCR[(Monster * Source.TemplateSourceCount * 4 + Template * 4 + HDInc) * 2];
	*CRSpace = Source.MonsterCR[(Monster * Source.TemplateSourceCount * 4 + Template * 4 + HDInc) * 2 + 1];

	if (Mixed && Source.MonsterTypeSource[Source.MonsterSource[Monster].Type].Mixed == 0)
	{
		CurCR += 1024;
	}

	if (Mixed && Source.TemplateSource[Template].Mixed == 0)
	{
		CurCR += 1024;
	}

	return(CurCR);
}

int DetermineMonster(clsChar* pChar)
{
	int *Prob, *CRPosCount, *MonsterTypePresent;

	p_nofree<int[32]> CRPosHD, CRPosCR, CRPosTemplate;

	CRPosTemplate = (int(*)[MAX_CR_POS]) pChar->Context.MonsterProb;
	CRPosHD = (int(*)[MAX_CR_POS]) pChar->Context.MonsterProb2;
	CRPosCR = (int(*)[MAX_CR_POS]) pChar->Context.MonsterProb3;

	int i, j, k;
	int manualold;

	int a, b;

	Prob = pChar->Context.TempProb;
	CRPosCount = pChar->Context.TempProb2;

	manualold = manual;

	if (ChooseClass)
	{
		manual = 1;
	}

	ZeroMemory(Prob, Source.MonsterSourceCount * sizeof(int));
	ZeroMemory(CRPosCount, Source.MonsterSourceCount * sizeof(int));

	int usetemplates = 0;
	if (boolrand(pChar->Context.seeda, "Use Templates", 5, 1, ChooseClass))
	{
		usetemplates = 1;
	}

	pChar->CRPosCount = 0;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		for (j = 0;j < 4;j++)
		{
			for (k = (usetemplates == 1 ? 1 : 0);k < (usetemplates == 1 ? 11 : 1);k++)
			{
				a = DetermineCR(i, j, k, &b, pChar->Mixed);
				if (a <= pChar->HG && b >= pChar->HG)
				{
					Prob[i] ++;
					if (k == 0)
					{
						Prob[i] += 15;
					}
					if (j == 0)
					{
						Prob[i] += 5;
					}
					CRPosHD[i][CRPosCount[i]] = j;
					CRPosTemplate[i][CRPosCount[i]] = k;
					CRPosCR[i][CRPosCount[i]] = a;
					CRPosCount[i]++;
					mCheckOverflow(CRPosCount[i], MAX_CR_POS, "Challenge Rating Possibilities", "MAX_CR_POS");
				}
			}
		}
	}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Prob[i])
		{
			if (manual != 1 && !BaseFrame.AllowEpic && Source.MonsterSource[i].Epic)
			{
				Prob[i] = 0;
			}
			else if (BaseFrame.LastMonster != -1)
			{
				if (i == BaseFrame.LastMonster)
				{
					Prob[i] *= 30;
				}
				else
				{
					Prob[i] *= Source.MonsterSource[i].Mixed;
				}
				if (Source.MonsterSource[BaseFrame.LastMonster].Type == Source.MonsterSource[i].Type)
				{
					Prob[i] *= 20;
				}
			}
		}
	}

	MonsterTypePresent = (int*) pChar->Context.MonsterProb4;
	ZeroMemory(MonsterTypePresent, Source.MonsterTypeSourceCount * sizeof(int));
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Prob[i])
		{
			MonsterTypePresent[Source.MonsterSource[i].Type] = 1;
		}
	}

	j = AdvancedRand(pChar->Context.seeda, Source.MonsterTypeSourceCount, MonsterTypePresent, sizeof(int),
		(char*) &Source.MonsterTypeSource[0].Name.buffer, sizeof(clsMonsterTypeSource), "Monsterart whlen!", ChooseClass, 1, 0, 0);

	if (j == -1)
	{
		return(1);
	}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Source.MonsterSource[i].Type != j)
		{
			Prob[i] = 0;
		}
	}
	
	pChar->MonsterName = AdvancedRand(pChar->Context.seeda, Source.MonsterSourceCount, Prob, sizeof(int), 
		(char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource),
		"Monster whlen", 0, 1);

	manual = manualold;
	
	pChar->CRPosCount = CRPosCount[pChar->MonsterName];
	for (i = 0;i < pChar->CRPosCount;i++)
	{
		pChar->CRPosTemplate[i] = CRPosTemplate[pChar->MonsterName][i];
		pChar->CRPosHD[i] = CRPosHD[pChar->MonsterName][i];
		pChar->CRPosCR[i] = CRPosCR[pChar->MonsterName][i];
	}
		
	if (BaseFrame.LastMonster == -1)
	{
		BaseFrame.LastMonster = pChar->MonsterName;
	}
	SetMonster(pChar);

	return(0);
}

void ValidateMonsterMods(clsChar* pChar)
{
	int i, tmp;
	pChar->ACRest = pChar->AC - 10 - pChar->ACArmor - pChar->ACDex - pChar->ACShield - pChar->ACSize;
	pChar->RWRefRest = pChar->RWRef - pChar->RWRefBase - pChar->RWRefAttr - pChar->RWRefMage;
	pChar->RWWilRest = pChar->RWWil - pChar->RWWilBase - pChar->RWWilAttr - pChar->RWWilMage;
	pChar->RWZaehRest = pChar->RWZaeh - pChar->RWZaehBase - pChar->RWZaehAttr - pChar->RWZaehMage;
	pChar->GAMeleeRest = pChar->GAMelee - pChar->GAMeleeAttr - pChar->GA - pChar->GASize;
	pChar->GAShotRest = pChar->GAShot - pChar->GAShotAttr - pChar->GA - pChar->GASize;
	for (i = 0;i < pChar->SkillCount;i++)
	{
		if (pChar->SkillRank[i] == 0 && pChar->SkillBonus[i] > 0) pChar->SkillRank[i] += pChar->Mods[Source.SkillSource[pChar->Skills[i]].Attr];
		tmp = min(pChar->MonsterLevel + (pChar->Mixed ? 0 : 3), pChar->SkillRank[i] - pChar->Mods[Source.SkillSource[pChar->Skills[i]].Attr]);
		pChar->SkillBonus[i] += pChar->SkillRank[i] - pChar->Mods[Source.SkillSource[pChar->Skills[i]].Attr] - tmp;
		pChar->SkillRank[i] = tmp;
		if (pChar->SkillRank[i] < 0)
		{
			tmp = -pChar->SkillRank[i];
			if (Source.SkillSource[pChar->Skills[i]].Untrained == 0)
			{
				tmp++;
			}
			pChar->SkillRank[i] += tmp;
			pChar->SkillMalus[i] -= tmp;
		}
	}
}
