class xRestartChar
{
};

class clsMonsterDescSource
{
public:
	string FileName;
	string Content;
	int MR;
};

class clsBonus
{
public:
	size_t Pointer;
	int Value;
	int Type;
	string Text;
};

template <class T> class ListA
{
public:
	ListA<T>* NextElem;
	T val;

	ListA()
	{
		NextElem = NULL;
	}

	~ListA()
	{
		if (NextElem)
		{
			delete NextElem;
			NextElem = NULL;
		}
	}
};

template <class T> class List : public T
{
public:
	List<T>* NextElem;

	List()
	{
		NextElem = NULL;
	}

	~List()
	{
		if (NextElem)
		{
			delete NextElem;
			NextElem = NULL;
		}
	}
};

template <class T> class p_nofree
{
public:
	T* ptr;

	T* operator =(T* ptr2)
	{
		return(ptr = ptr2);
	}

	inline operator T*() const
	{
		return(ptr);
	}
};

template <class T> class p
{
public:
	T* ptr;

	p()
	{
		ptr = NULL;
	}

	p(T *setPtr)
	{
		ptr = setPtr;
	}

	~p()
	{
		freep();
	}

	void freep()
	{
		if (ptr)
		{
			freel(ptr);
			ptr = NULL;
		}
	}

	T* operator =(T* ptr2)
	{
		return(ptr = ptr2);
	}

	inline operator T*() const
	{
		return(ptr);
	}
};

struct structBaseFrame
{
	int DrawType;
	int CalcType;
	int AllowEpic;
	int LastMonster;
};

struct GroupTemplate
{
	int CharCount;
	int FullCR;
};

struct CharTemplate
{
	int TemplateType;
	int AttributeType;
	int MinLevel;
	int MaxLevel;
	int* Class;
	int ClassCount;
	int* AttributePreset;
	int Monster;
	int MonsterName;
	int MonsterNameHD;
	int MonsterNameTemplate;
	int Mixed;
	int Treasure;
	int NPCClass;
	int Race;

	int TreasureMin;
	int TreasureMax;

	int Life;

	bool Saved;

	structBaseFrame BaseFrame;
	int Reproduce;

	struct seedstru
	{
		unsigned long seed[517];
	} seed;
	struct restru
	{
		unsigned long retemp[REPRODUCE_SAVE];
		unsigned long repos;
	} re;
	struct consolestru
	{
		unsigned char order;
		char manual;
		char ChooseClass;
		bool UseIsaac;
		int param;
	} console[CONSOLE_SAVE];
	unsigned int consolepos;
};

struct clsSourceFake
{
	basestring Name;
};

struct clsMonsterSource
{
#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
	logstring Name;
	logstring MonsterDesc;
	int CR;
	int Type;
	int Size;
	int Epic;
	int HD;
	int HDType;
	int TPBonus;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int Attr[ATTRIBUTE_COUNT];
	int AC;
	int HDMin;
	int HDMax;
	int HDInc;
	int HDInc2;
	int Init;
	int Speed;
	int OrgMin;
	int OrgMax;
	int Mixed;
	int Treasure;
	int AttackBonus[6];
	int AttackNumber[6];
	int AttackRed[6];
	int DamageA[6];
	int DamageB[6];
	int DamageC[6];
	logstring AttackType[6];
	int AlternateAttack[6];
	int AttackCount;
	int Feats[6];
	int FeatCount;
	int Skills[7];
	int SkillLevels[7];
	int SkillCount;
	char* SpellChar;
	int ClericSpells;
	char* Familiar;
	p<int> AbbilityCode;
	int MR;
};

struct clsPowerSource
{
	logstring Name;
	int Psion;
	int PsychicW;
	int Attribute;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEffectSource
{
	logstring Name;
	int Weapon;
	int Armor;
	int Shield;
	int Helmet;
	int Gloves;
	int Boots;
	int Belt;
	int Cloak;
	int Ring;
	int Amulet;
	int Westment;
	int Bracers;
	int Fight;
	int Magic;
	int Shadow;
	int Divine;
	int Multi;
	int Cost;
	int Cost2;
	int Quality;
	char* Script;
	p<int> SkillCode;
	char* Variable;
	int Ranged;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSpellSource
{
	basestring Name;
	int Probability;
	int* ClassLevels;
	int DomainCount;
	int DomainLevel;
	int Domains[2];
	int School;
	int Convert;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEquipSource
{
	logstring Name;
	int EquipType;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int* Probability;
	int* RaceProbability;
	int StdProb;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int SpecialType;
	int MinLevel;
	int Rare;
	int Price;
	char* Script;
	int ForbidEffects;
	int Amount;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEquip
{
	int ID;
	int EquipType;
	int Enhencement;
	int Effect[MAX_EFFECTS];
	int EffectVariable[MAX_EFFECTS];
	int EffectCount;
	int EffectCountA;
	int ForceEffects;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int CriticalBonus;
	int AttackType;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int AttackBonus;
	int AttackBonusA;
	int TwoWeapon;
	int TwoWeaponSecond;
	int TwoHand;
	int MaxStr;
	int Primary;
	int Secondary;
	int Value;
	int BaseValue;
	int Adamantine;
	int Mithril;
	int Mercury;
	int Masterwork;
	int ShieldUsed;
	int IncludeInTreasure;
	int MaxEnh;

	struct clsEquip_strings
	{
		string EquipDesc;
		string EffectDesc[MAX_EFFECTS];
	} strings;

	int Specific;

	int FinalAttackBonus;
	int FinalMalus;
	int FinalDamage3;
};

struct clsRaceSource
{
	logstring Name;
	int Probability;
	int Size;
	int PreferedAttackType;
	char* Script;
	int RaceModBin[6];
	int Range;
	int SubRaceBin;
	int HGMod;
	char* RaceFeats;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsChar;

struct clsVolatileChar
{
	int HG;

	List<clsBonus>* Boni;

	int CRPosCount;
	int CRPosHD[32];
	int CRPosTemplate[32];
	int CRPosCR[32];

	int Profiled;
	int ProfileStrength;
	int Profile;

	int Mixed;
	int MixedHG;

	int HasTemplate;

	int Rel;
	int NPCClass;

	__int64 CreationTime;
	__int64 MixedTime;
	int DisplayTime;

	int Attributes[ATTRIBUTE_COUNT];
	int Mods[ATTRIBUTE_COUNT];
	int IgnoreAttr[ATTRIBUTE_COUNT];

	int ClassCount;
	int Classes[MAX_CLASSES];
	int DummyClass[MAX_CLASSES];
	int DummyClassClericSpells[MAX_CLASSES];
	int Level;
	int MonsterLevel;
	int Levels[MAX_CLASSES];
	int LevelsClassic[MAX_CLASSES];
	int CasterLevel[MAX_CLASSES];

	int Life;
	int LifeBonus;
	int TPLeft;
	
	int GA;
	int GASize;
	int GAMelee;
	int GAShot;
	int GAMeleeAttr;
	int GAShotAttr;
	int GAMeleeRest;
	int GAShotRest;
	int GAEpic;
	
	int RWEpic;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int RWRefBase;
	int RWWilBase;
	int RWZaehBase;
	int RWRefAttr;
	int RWWilAttr;
	int RWZaehAttr;
	int RWRefMage;
	int RWWilMage;
	int RWZaehMage;
	int RWRefRest;
	int RWWilRest;
	int RWZaehRest;
	
	int FeatCount;
	int Feats[MAX_FEATS];
	int FeatDependancy[MAX_FEATS];
	int FeatDone[MAX_FEATS];
	int FeatTypeRequired[FEAT_TYPE_COUNT];
	int WeaponArmorShieldFeats;
	int InbornLeft;
	int BonusFeatCountLast;
	int BonusFeatCount;

	int AttackType[2];
	int AttackTypeCount;
	int Attacks;
	int Attacks2;
	int BonusAttacks;
	int AttacksOpportunity;
	int MonkAttacks;
	
	int EquipCount;
	clsEquip Equipment[MAX_EQUIP];
	int EquipTreasureCount;
	int EquipTreasureStart;
	int RingMax;
	int dart;
	
	int Skills[MAX_SKILLS];
	int SkillRank[MAX_SKILLS];
	int SkillRank2[MAX_SKILLS];
	int SkillBonus[MAX_SKILLS];
	int FinalSkillBonus[MAX_SKILLS];
	int SkillMalus[MAX_SKILLS];
	int SkillTotal[MAX_SKILLS];
	int SkillCount;
	int SkillCountReal;
	int SkillRequired[MAX_SKILLS];
	int BonusSkillPointCount;
	int BonusSkillPointCountLast;

	int Race;
	int SubRace;

	int SpellsKnownCount[MAX_CLASSES][10];
	int SpellList[MAX_CLASSES][10][10];
	int SpellsPerDayCount[MAX_CLASSES][10];
	int SpellListCount[MAX_CLASSES][10];
	int BonusSpells;
	int BonusSpellLevelMin;
	int BonusSpellLevelMax;
	int HighestSpell;
	int SpellFailure;
	int TargetClass;

	int Domains[MAX_DOMAINS];
	int DomainCount;
	int DomainSpells[10];
	int DomainSpellCount;

	int Specialised;
	int School;
	int SchoolForbidden[MAX_SCHOOLS];

	int SchoolDC[MAX_SCHOOLS];
	int ArcaneDC;
	int DivineDC;
	int GeneralDC;

	int AC;
	int ACArmor;
	int ACShield;
	int ACDex;
	int ACSize;
	int ACRest;
	int MaxDex;
	int ArmorMalus;
	
	float Range;
	
	int MR;
	int MRBonus;
	int againstMR;
	
	int SpecialAbbilities;
	int Lores;
	int Arcanas;
	int HierophantAbilities;

	int Initiative;
	int InitiativeRest;
	int InitiativeDex;
	
	int AttackMod;
	int DmgMod;

	int Money;
	int MoneyRest;
	int Treasure;
	int TreasureLeft;
	int TreasureSellValue;

	int UnarmedDamage1;
	int UnarmedDamage2;
	
	int PowerPoints;
	int MainDisciple;
	int DiscipleDC[ATTRIBUTE_COUNT];
	int PsionicDC;
	int CrystalCount;
	int CombatModes;
	
	int Monster;
	int MonsterName;
	int MonsterType;
	int MAttackBonus[6];
	int MAttackNumber[6];
	int MAttackRed[6];
	int MDamageA[6];
	int MDamageB[6];
	int MDamageC[6];
	int MAlternateAttack[6];
	int MAttackCount;
	int MSize;
	int MonsterTWType;
	int MonsterSize;

	int SneakDmg;
	int Evasion;
	int Smite;
	int Dex2AC;
	int UncannyDodge;
	int LowLightVision;
	int DarkVision;
	int ShareSpells;
	int EmpathicLink;
	int SpeakWithMaster;
	int Concealment;
	int LayOnHands;
	int SacretDefense;
	int PoisonUse;
	int SurpremeCleave;
	int TouchReach;

	int FinalSpellFailure;
	int FinalArmorMalus;
	int FinalLife;
	int FinalMR;
	int FinalAttacks;

	int protection;
	int protectionmissed;
	int classlevel;
	int* sAddfeatsyet;
	bool NoScriptVarSet;

	int Familiar;
	clsChar* pFamiliar;

	int AnimalCompanion;
	int AnimalCount;
	clsChar* pAnimalCompanion;

	int Mount;
	clsChar* pMount;

	int Servant;
	clsChar* pServant;

	clsVolatileChar()
	{
		pFamiliar = NULL;
		pAnimalCompanion = NULL;
		pMount = NULL;
		pServant = NULL;
		Boni = NULL;
	}

	~clsVolatileChar()
	{
		if (Boni)
		{
			delete Boni;
			Boni = NULL;
		}
	}
};

struct clsChar : public clsVolatileChar
{
	struct clsChar_strings
	{
		string CharText;
		string CharTextPrimary;
		string CharTextSecondary;
		string CharTextTwo;
		string MAttackType[6];
		string tempstring1, tempstring2;
	} strings;

	CharTemplate* CreationTemplate;

	struct clsCharContext
	{
		char* EffectDone;
		unsigned int* AgainDep;
		char* FeatNotAgain;
		int* ClassSkills;
		short int* SpecialCount;
		char tempstring[SMALL_BUFFER_LEN];
		char tempout[BUFFER_LEN];
		clsChar* CDummy;
		CharTemplate* CTDummy;
		unsigned long* seeda;
		int FetchVarCounter[26];
		int *TempProb, *TempProb2, *EffectProb, *EffectProb2, *SpecificProb, *FeatProb, *FeatProb2, *FeatProb3, *MonsterProb, *MonsterProb2, *MonsterProb3, *MonsterProb4, *HenchmenProb, *HenchmenProb2;
	} Context;

	int DummyChar;
	clsChar* dummySource;
	int HenchmenChar;

	clsChar()
	{
		dummySource = NULL;
		HenchmenChar = DummyChar = 0;
	}

	void delete_subchars()
	{
		if (pFamiliar)
		{
			delete pFamiliar;
			pFamiliar = NULL;
		}
		if (pAnimalCompanion)
		{
			delete[] pAnimalCompanion;
			pAnimalCompanion = NULL;
		}
		if (pMount)
		{
			delete pMount;
			pMount = NULL;
		}
		if (pServant)
		{
			delete pServant;
			pServant = NULL;
		}
	}

	~clsChar()
	{
		delete_subchars();
	}
};

struct clsCharSource
{
	int Count;
	logstring Name;
	int TW;
	int AttributePriority[ATTRIBUTE_COUNT];
	int Probability;
	int GA;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int PreferedAttack;
	int ForceAttack;
	int Skills;
	int Prestige;
	int MaxLevel;
	int MaxLevelA;
	char* Script;
	char* ClassFeats;
	int SpellType;
	int SpellType2;
	int IncreaseSpellType;
	int SpontanCast;
	int SpontanCast2;
	int Domains;
	int Specialize;
	int PowerType;
	p<int> ReqCode;
	p<int> SkillCode;
	p<int> FeatCode;
	logstring BonusFeatType;
	logstring BonusFeats;
	int EpicFeats;
	int SpellFailure;
	int UseEffects;
	int AttachClassNum;
	int NoEq;
	int PsionicDisciple;
	int PsiCrystal;
	int ForceWeaponType;
	int NaturalEnhence;
	int NPC;
	int SpellAttr;
	int BonusClassSkills;
	int ForceWeaponNum;
	int NoMetal;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsFeatSource
{
	logstring Name;
	int* Probability;
	int MultipleTimes;
	int Epic;
	p<int> ReqCode;
	int CopyDepFrom;
	p<int> SkillCode;
	int DepType;
	char* Script;
	int AttackDep;
	int FeatType;
	logstring Text;
	int Inborn;
	int* Rel;
	int RelCount;
	int Standard;
	int Exclusive;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSkillSource
{
	logstring Name;
	int* Prob;
	int Attr;
	p<int> SynCode;
	int Untrained;
	int ArmorMalus;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsDomainSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsMonsterTypeSource
{
	logstring Name;
	int GAType;
	int RWRefType;
	int RWWilType;
	int RWZaehType;
	int Mixed;
	int MixedEq;
	int Skills;
	int Feats;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsRegionSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSchoolSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSizeSource
{
	logstring Name;
	int Mods[3];
	int AC;
	int SizeMod;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsAbbilitySource
{
	logstring Name;
	logstring Text;
	char* Script;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSpecialSource
{
	logstring Name;
	int Type;
	int SpellLevel;
	char* Script;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsTemplateSource
{
	logstring Name;
	char* CRScript;
	int Mixed;
	logstring ForceType;
	logstring ForbitType;
	char* Script;
	int AttributeMod[ATTRIBUTE_COUNT];
	logstring NewType;
	logstring TemplateDesc;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsBonusSource
{
	logstring Name;
	int Stack;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct ProfileFeatStruct
{
	int Feat;
};

struct ProfileClassStruct
{
	int Class;
	int Level;
};

struct ProfileWeaponStruct
{
	int Weapon;
};

struct ProfileSkillStruct
{
	int Skill;
	int MinLvl;
	int MaxLvl;
};

struct ProfileSpellStruct
{
	int Spell;
	int MaxNum;
};

struct ProfileEffectStruct
{
	int Effect;
};

struct clsSpecificSource
{
	logstring Name;
	int On;
	int Price;
	char* script;
	p<int> SkillCode;
	int Fight;
	int Mage;
	int Shadow;
	int Divine;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct ProfileStruct
{
	char ProfileName[256];
	
	ProfileClassStruct Classes[MAX_PROFILE_CLASSES];
	int ClassCount;

	ProfileWeaponStruct Weapons[MAX_PROFILE_WEAPONS];
	int WeaponCount;
	
	ProfileFeatStruct Feats[MAX_PROFILE_FEATS];
	int FeatCount;

	ProfileSkillStruct Skills[MAX_PROFILE_SKILLS];
	int SkillCount;
	
	ProfileSpellStruct Spells[MAX_PROFILE_SPELLS];
	int SpellCount;

	ProfileEffectStruct Effects[MAX_PROFILE_EFFECTS];
	int EffectCount;

	int Specials[MAX_PROFILE_SPECIALS];
	int SpecialCount;

	int Armor;
	int Shield;
	int ArmorType;
	int ShieldUse[2];

	int AttackType[2];

	int Race;
	int PreferedSchool;

	int AttributePriority[ATTRIBUTE_COUNT];

	int MinLevel;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSource
{
	clsCharSource*	CharSource;
	int CharSourceCount;
	clsFeatSource* FeatSource;
	int FeatSourceCount;
	clsEquipSource* EquipSource;
	int EquipSourceCount;
	clsSkillSource* SkillSource;
	int SkillSourceCount;
	clsRaceSource* RaceSource;
	int RaceSourceCount;
	clsSpellSource* SpellSource;
	int SpellSourceCount;
	clsPowerSource* PowerSource;
	int PowerSourceCount;
	clsEffectSource* EffectSource;
	int EffectSourceCount;
	clsSpecificSource* SpecificSource;
	int SpecificSourceCount;
	clsMonsterSource* MonsterSource;
	int MonsterSourceCount;
	int* MonsterCR;

	ProfileStruct* Profiles;
	int ProfileCount;

	clsSchoolSource* SchoolSource;
	int SchoolSourceCount;
	clsSizeSource* SizeSource;
	int SizeSourceCount;
	clsMonsterTypeSource* MonsterTypeSource;
	int MonsterTypeSourceCount;
	clsDomainSource* DomainSource;
	int DomainSourceCount;
	clsTemplateSource* TemplateSource;
	int TemplateSourceCount;
	clsRegionSource* RegionSource;
	int RegionSourceCount;
	clsAbbilitySource* AbbilitySource;
	int AbbilitySourceCount;

	clsSpecialSource* SpecialSource;
	int SpecialSourceCount;
	clsBonusSource* BonusSource;
	int BonusSourceCount;

	string AttributeNames[ATTRIBUTE_COUNT];

	int StartMoney[51];
	int Treasure[51];

	int EquipTypeFeats[3][3];

	char* lpSymbolStart;
	unsigned int dwSourceCountMax;
};

struct clsTempFeatSource
{
	basestring ReqStr;
	basestring SkillStr;
};
struct clsTempCharSource
{
	basestring Derrive;
	basestring SkillStr;
	basestring ReqStr;
	basestring CopySpellList;
	basestring AttachClass;
	basestring ForceWeapon;
	basestring FeatStr;
};
struct clsTempEffectSource
{
	basestring SkillBoost;
};
struct clsTempSkillSource
{
	basestring Synergy;
};
struct clsTempSpecificSource
{
	basestring SkillBoost;
};
struct clsTempRaceSource
{
	basestring SubRace;
};
struct clsTempMonsterSource
{
	basestring Abbilities;
};

struct clsTempSource
{
	clsTempCharSource* CharSource;
	clsTempFeatSource* FeatSource;
	clsTempEffectSource* EffectSource;
	clsTempSkillSource* SkillSource;
	clsTempSpecificSource* SpecificSource;
	clsTempRaceSource* RaceSource;
	clsTempMonsterSource* MonsterSource;

	List<clsMonsterDescSource>* MonsterDesc;

	clsTempSource()
	{
		ZeroMemory(this, sizeof(clsTempSource));
	}
};

extern "C" clsSource Source;

#ifdef INCLUDE_REBUILD
extern "C" clsTempSource TempSource;
#endif

class clsScriptContextA : public clsScriptContext
{
public:
	clsChar* pCurChar;
	clsEquip* pCurEquip;
	int nCurFeat;
	string *pCurText, *pCurMainText, *pCurSubText;
};

struct clsThreadData
{
	int n;
	int start;
	int end;
	bool primary;
	HANDLE handle;
};
