void ClearChar(clsChar* pChar)
{
	#ifdef GCC_RUNTIME
	int gcc_tmp_stack;
	#endif

	int i, k;

	pChar->clsVolatileChar::~clsVolatileChar();
	pChar->delete_subchars();
	ZeroMemory(pChar, sizeof(clsVolatileChar));
	
#ifdef GCC_RUNTIME

	asm("movl %%esp, %[w_tmp]\n"
		"movl %[r_ptr], %%eax\n"
		"push %%eax\n"
		"movl %%eax, (%%esp)\n"
		"call __ZN8gccspace15clsVolatileCharC2Ev\n"
		"movl %[r_tmp], %%esp\n"
		:[w_tmp] "=m" (gcc_tmp_stack)
		:[r_ptr] "m" (pChar), [r_tmp] "m" (gcc_tmp_stack)
		:"eax", "ebx", "ecx", "edx", "esi", "edi"
		);
#else
	pChar->clsVolatileChar::clsVolatileChar();
#endif

	for (i = 0;i < sizeof(clsChar::clsChar_strings) / sizeof(string);i++)
	{
		((string*) &pChar->strings)[i].reset();
	}

	for (i = 0;i < MAX_DOMAINS;i++)
	{
		pChar->Domains[i] = -1;
	}
	
	for (k = 0;k < 32;k++)
	{
		for (i = 0;i < 10;i++)
		{
			pChar->SpellsKnownCount[k][i] = -1;
			pChar->SpellsPerDayCount[k][i] = -1;
			pChar->SpellListCount[k][i] = -1;
		}
	}
	pChar->Attacks = 1;
	pChar->AttacksOpportunity = 1;
	pChar->MaxDex = 1024;

	pChar->RingMax = 2;

	pChar->InbornLeft = 1;
	pChar->SubRace = -1;

	ZeroMemory(pChar->Context.EffectDone, Source.EffectSourceCount * sizeof(char));
	ZeroMemory(pChar->Context.AgainDep, Source.FeatSourceCount * sizeof(int));
	ZeroMemory(pChar->Context.FeatNotAgain, Source.FeatSourceCount * sizeof(char));
	ZeroMemory(pChar->Context.ClassSkills, Source.SkillSourceCount * sizeof(int));
	ZeroMemory(pChar->Context.SpecialCount, Source.SpecialSourceCount * sizeof(short int));
}

void CreateCharInit(clsChar* pChar)
{
	int i;

	if (readreproduce = (pChar->CreationTemplate->Reproduce || UseReHeaderSave))
	{
		CopyMemory(&BaseFrame, &pChar->CreationTemplate->BaseFrame, sizeof(structBaseFrame));
		UseIsaac = (pChar->CreationTemplate->TemplateType == 49);
		IsaacInitDone = false;
		pChar->CreationTemplate->Reproduce = 0;
	}
	else
	{
		CopyMemory(&pChar->CreationTemplate->BaseFrame, &BaseFrame, sizeof(structBaseFrame));
		pChar->CreationTemplate->consolepos = 0;
	}

	if (useagaincount == 0 && ChooseClass == 0 && manual == 0 && manual2 == 0 && readreproduce == 0)
	{
		UseIsaac = true;
		reproduceisaac = 1;
		reproduce = 0;
	}
	else if (readreproduce == 0)
	{
		UseIsaac = false;
	}

	prepos = (unsigned int*) &CTtmp.re.repos;
	retemp = (unsigned int*) &CTtmp.re.retemp[0];
	*prepos = 0;

	readreproducea = readreproduce;
		
	if (readreproduce == 0 && pChar->CreationTemplate->Saved)
	{
		isaacinitrand();
		pChar->CreationTemplate->Saved = false;
	}
	
	if (UseIsaac)
	{
		if (!IsaacInitDone)
		{
			if (readreproduce)
			{
				isaacrestoreseed(pChar->Context.seeda, &pChar->CreationTemplate->seed.seed[0]);
			}
			else
			{
				isaacinitrand();
			}
			IsaacInitDone = true;
		}
		isaacsaveseed(pChar->Context.seeda, &pChar->CreationTemplate->seed.seed[0]);

		readreproducea = readreproduce = 0;
		pChar->CreationTemplate->TemplateType = 49;
	}
	else
	{
		pChar->CreationTemplate->TemplateType = 48;
	}

	prepos = (unsigned int*) &pChar->CreationTemplate->re.repos;
	retemp = (unsigned int*) &pChar->CreationTemplate->re.retemp[0];
	*prepos = 0;
	if (readreproduce) (*prepos)++;

	if (UseIsaac && (qon_DebugOutput || logverbose >= 2))
	{
		qprinta(2)("Charakter Seed:\n");
		for (i = 0;i < 517;i++)
		{
			qprinta(2)("%2X", pChar->CreationTemplate->seed.seed[i]);
		}
		qprinta(2)("\n\n");
	}

	CopyMemory(&reheader, pChar->CreationTemplate, sizeof(CharTemplate));
#ifdef AUTO_SAVE
	if (UseIsaac && !fNoAutoSave)
	{
		saverep("predefault.rep", false, pChar->CreationTemplate);
	}
#endif

}

void CreateCharExit(clsChar* pChar)
{
	if (*prepos % 2) (*prepos)--;
	if (pChar->CreationTemplate->Life == -100)
	{
		pChar->TPLeft = pChar->Life;
		pChar->CreationTemplate->Life = pChar->Life;
	}
	else
	{

		pChar->TPLeft = pChar->CreationTemplate->Life;
	}
	if (!UseIsaac)
	{
		reproduce = 1;
	}
		
#ifdef AUTO_SAVE
	if (!fNoAutoSave)
	{
		saverep("default.rep", false, pChar->CreationTemplate);
	}
#endif
	readreproducea = 0;
}

void CreateChar(clsChar* pChar, bool child)
{
	int i, typetemp;
	LARGE_INTEGER qwStartTime, qwEndTime;

	QueryPerformanceCounter(&qwStartTime);

	if (child == false)
	{
		CreateCharInit(pChar);
	}

	ClearChar(pChar);

	if (pChar->CreationTemplate->Treasure)
	{
		CreateTreasure(pChar);
		goto CreateCharEnd;
	}

	pChar->Rel = AdvancedRand(pChar->Context.seeda, Source.RegionSourceCount, &FixedProb, 0, (char*) &Source.RegionSource[0].Name.buffer, sizeof(clsRegionSource), "Region auswhlen!", 0, 1);

	qprinta(2)("Starting Character Creation\n");

	if (pChar->CreationTemplate->Monster == -1)
	{
		pChar->Monster = random(pChar->Context.seeda, 0, 1, "0 Char / 1 Monster", ChooseClass);
	}
	else
	{
		pChar->Monster = pChar->CreationTemplate->Monster;
	}

	manual = manual2;
	qprinta(1)("\nHG wird festgelegt\n");

	pChar->HG = random(pChar->Context.seeda, pChar->CreationTemplate->MinLevel, pChar->CreationTemplate->MaxLevel, "HG der Kreatur whlen!\n", 0);

	if (pChar->Monster)
	{
RedoMixed:
		if (pChar->HG > 1 &&
			(pChar->CreationTemplate->Mixed || (pChar->CreationTemplate->Monster == -1 && boolrand(pChar->Context.seeda, "Mixed Charakter?", 5, 1, ChooseClass))))
		{
			pChar->Mixed = 1;
			i = random(pChar->Context.seeda, 0, pChar->HG, "Wie viel der HG fr Klasse verwnden?", ChooseClass);
			pChar->HG -= i;
			pChar->MixedHG = i;
		}
		else
		{
			pChar->Mixed = 0;
		}

		if (pChar->CreationTemplate->MonsterName == -1)
		{
			if (DetermineMonster(pChar) == 1)
			{
				if (pChar->Mixed)
				{
					pChar->HG += pChar->MixedHG;
					pChar->MixedHG = 0;
				}
				goto RedoMixed;
			}
		}
		else
		{
			pChar->MonsterName = pChar->CreationTemplate->MonsterName;

			pChar->CRPosCount = 1;
			pChar->CRPosHD[0] = 0;
			pChar->CRPosTemplate[0] = pChar->CreationTemplate->MonsterNameTemplate;
			pChar->CRPosCR[0] = pChar->CreationTemplate->MinLevel;

			SetMonster(pChar);
		}

		CalculateSpellCount(pChar);
		CalculateSpells(pChar);

		ValidateMonsterMods(pChar);

		DoMonsterFinalVals(pChar);
	}
	else
	{
		pChar->Level = pChar->HG + 1;
		if (!(pChar->NPCClass = pChar->CreationTemplate->NPCClass))
		{
			DoTemplateProfile(pChar);
		}

		if (pChar->Profiled)
		{
			typetemp = 1;
		}
		else if (pChar->CreationTemplate->AttributeType == -1)
		{
			if (manual == 1) typetemp = 2;
			else typetemp = random(pChar->Context.seeda, 1, 2, "Wrfelmethode whlen: 1 = 3W6, 2 = 4W6\n", 0);
		}
		else
		{
			typetemp = pChar->CreationTemplate->AttributeType;
		}

		if (pChar->CreationTemplate->Monster == -1 && !pChar->Profiled && !pChar->HasTemplate)
		{
			pChar->NPCClass = boolrand(pChar->Context.seeda, "NPC Klassen verwenden?", 20, 1, ChooseClass);
		}

		if (pChar->NPCClass)
		{
			pChar->Level += 1 + (pChar->Level - pChar->MonsterLevel) / 5;
		}

		if (pChar->CreationTemplate->AttributePreset == 0)
		{
			RandAttributes(pChar, typetemp);
		}
		else
		{
			CopyMemory(pChar->Attributes, pChar->CreationTemplate->AttributePreset, ATTRIBUTE_COUNT * sizeof(int));
			if (pChar->DummyChar) for (i = 0;i < ATTRIBUTE_COUNT;i++) if (pChar->Attributes[i] == 0) pChar->IgnoreAttr[i] = 1;
		}

		ChooseRace(pChar);

		DoClasses(pChar, typetemp);

		RaceMod(pChar);
	
		IncreaseAttributes(pChar);
		if (pChar->HasTemplate)
		{
			IncreaseMonsterAttributes(pChar, Source.TemplateSource[pChar->HasTemplate].AttributeMod, ATTRIBUTE_COUNT, 1);
		}
		CalcMods(pChar);
		CalcGARW(pChar);

		pChar->WeaponArmorShieldFeats = 1;
		if (Source.CharSource[pChar->Classes[HighestVal(pChar->Levels, pChar->ClassCount)]].NoEq == 2)
		{
			if (boolrand(pChar->Context.seeda, "Get All Required Feats for Weapon/Armor/Shield", 1, 3) == 0)
			{
				pChar->WeaponArmorShieldFeats = 0;
			}
		}

		mCheckCharsFirst(PsiCrystal);
		if (mCheckCharsResult)
		{
			pChar->CrystalCount++;
		}

		int tempval = 0;
		DoClassRaceFeats(pChar, &tempval);
		DoLores(pChar);
		DoHierophantAbilities(pChar);

		manual = manual2;
		qprinta(1)("\nAngriffsart wird bestimmt\n");

		DetermineAttackType(pChar);

		manual = manual2;
		qprinta(1)("\nAusrstung wird bestimmt\n");

		if (pChar->HenchmenChar == 0 && (
				(pChar->DummyChar == 0) ||
				(Source.MonsterTypeSource[pChar->dummySource->MonsterType].MixedEq == 1) ||
					(Source.MonsterTypeSource[pChar->dummySource->MonsterType].MixedEq > 1 &&
					boolrand(pChar->Context.seeda, "Monster mit Ausrstung?", Source.MonsterTypeSource[pChar->dummySource->MonsterType].MixedEq - 1, 1))
			))
		{
			GenerateEquipment(pChar);
			DoEquipmentEffects(pChar);
		}

		if (pChar->HenchmenChar)
		{
			pChar->Treasure = 0;
		}
		else if (pChar->DummyChar)
		{
			pChar->Treasure = pChar->dummySource->Treasure;
		}
		else
		{
			pChar->Treasure = random(pChar->Context.seeda, 75, 125, "Geldwert in %%") * Source.Treasure[pChar->HG] / 100 * 2;
		}

		InherentBonus(pChar);

		manual = manual2;
		qprinta(1)("\nZauber etc werden bestimmt\n");

		CalcMods(pChar);
		DoDomainsSpecial(pChar);
		CalculateSpellCount(pChar);
		DoArcanas(pChar);
		CalculateSpells(pChar);
		DoPowers(pChar);

		manual = manual2;
		qprinta(1)("\nTalente werden festgelegt\n");

		if (pChar->DummyChar)
		{
			for (i = 0;i < pChar->dummySource->FeatCount;i++)
			{
				if (Source.FeatSource[pChar->dummySource->Feats[i]].MultipleTimes != 2 || !FeatPresent(pChar, pChar->dummySource->Feats[i], pChar->FeatCount, pChar->dummySource->FeatDependancy[i]))
				{
					AddFeat(pChar, pChar->dummySource->Feats[i], NULL, pChar->dummySource->FeatDependancy[i]);
				}
			}
		}

		CalculateTypeFeats(pChar);
		CalculateFeats(pChar);
		SetFeatClassSkills(pChar);

		manual = manual2;
		qprinta(2)("\nFertigkeiten werden festgelegt\n");

		CalculateSkills(pChar);
		SetFeatSkillsA(pChar);
		CalcMods(pChar);
		CalcGARW(pChar);
		manual = manual2;

		DoFeatEffects(pChar);

		CalcMods(pChar);
		DoRaceFeatures(pChar);
		DoClassFeatures(pChar);

		DoEffects4(pChar);
		CalcMods(pChar);
		CalcGARW(pChar);	

		DoCrystal(pChar);
		
		manual = manual2;
		DoHenchmen(pChar);

		for (i = 0;i < ATTRIBUTE_COUNT;i++) if (pChar->IgnoreAttr[i]) pChar->Attributes[i] = 0;
		manual = manual2;
		CalcLife(pChar);

		DoFinalVals(pChar);

		FinishSkills(pChar);

		if (pChar->HasTemplate)
		{
			pChar->strings.CharText += Source.TemplateSource[pChar->HasTemplate].TemplateDesc;
		}
	}

	ConvertVals2CharText(pChar);
	for (i = 0;i < ATTRIBUTE_COUNT;i++) if (pChar->IgnoreAttr[i]) pChar->Attributes[i] = 0;

	if (pChar->Mixed == 1)
	{
		if (loop == 0 && fDropMsg == false)
		{
			qprintf("Creating Mixed Char\n");
		}
		MixChar(pChar);
	}
	
	StripFeats(pChar);
	SummarizeSkills(pChar);

	ReArrangeFeats(pChar);
	ReArrangeSkills(pChar);

	pChar->EquipTreasureStart = pChar->EquipCount;

	if (pChar->DummyChar == 0 && pChar->HenchmenChar == 0)
	{
		CreateCharTreasure(pChar);
	}

CreateCharEnd:

	if (pChar->DummyChar == 0 && pChar->HenchmenChar == 0)
	{
		InsertTreasure(pChar);
	}

	DoSellValue(pChar);

	if (child == false)
	{
		if (pChar->CreationTemplate->consolepos)
		{
			ReConsole(pChar);
		}
		CreateCharExit(pChar);
	}

	QueryPerformanceCounter(&qwEndTime);
	pChar->CreationTime = max(1, (int) ((qwEndTime.QuadPart - qwStartTime.QuadPart) * 1000000 / qwFreq));
}

#include "clsCharDisplay.h"
