char valuebuffer[BUFFER_LEN];
char* valuepointer;
void PrepareString(int num, char* Key)
{
	size_t j, k;
	GetPrivateProfileString(Source.Profiles[num].ProfileName, Key, "", valuebuffer, BUFFER_LEN - 1, PROFILE_FILE);
	k = strlen(valuebuffer);
	valuebuffer[k + 1] = 0;
	for (j = 0;j < k;j++)
	{
		if (valuebuffer[j] == 32) {qprintf("Error in Profile Database\n");quitprog();}
		if (valuebuffer[j] == 44) {valuebuffer[j] = 0;}
		if (valuebuffer[j] == 58) {valuebuffer[j] = 32;}
	}
	valuepointer = valuebuffer;
}

char tempbuffer[BUFFER_LEN];
int tempint, tempint2;

int ProfileSourceInit()
{
	char profilebuffer[BUFFER_LEN];
	char* profilepointer = profilebuffer;
	int i;

	Source.ProfileCount = 0;

	GetPrivateProfileSectionNames(profilebuffer, BUFFER_LEN - 1, PROFILE_FILE);
	qprinta(2)("Profiles: ");
	while (*profilepointer != 0)
	{
		qprinta(2)(" %s ", profilepointer);
		profilepointer += strlen(profilepointer) + 1;
		Source.ProfileCount++;
	}
	qprinta(2)("\n");

	SetNewIdent("ProfileSourceInit-Profiles");
	Source.Profiles = new ProfileStruct[Source.ProfileCount];

	profilepointer = profilebuffer;

	for (i = 0;i < Source.ProfileCount;i++)
	{
		strcpy(Source.Profiles[i].ProfileName, profilepointer);
		profilepointer += strlen(profilepointer) + 1;
		
		PrepareString(i, "Classes");
		Source.Profiles[i].ClassCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].ClassCount, MAX_PROFILE_CLASSES, "Profile Class", "MAX_PROFILE_CLASSES");
			sscanf(valuepointer, "%s %d", tempbuffer, &tempint);
			Source.Profiles[i].Classes[Source.Profiles[i].ClassCount].Class = GetCharNumber(tempbuffer);
			Source.Profiles[i].Classes[Source.Profiles[i].ClassCount].Level = tempint;
			Source.Profiles[i].ClassCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "AttackType");
		Source.Profiles[i].AttackType[0] = valuebuffer[0] - 48;
		Source.Profiles[i].AttackType[1] = valuebuffer[1] - 48;

		PrepareString(i, "Weapons");
		Source.Profiles[i].WeaponCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].WeaponCount, MAX_PROFILE_WEAPONS, "Profile Weapons", "MAX_PROFILE_WEAPONS");
			Source.Profiles[i].Weapons[Source.Profiles[i].WeaponCount].Weapon = GetEquipNumber(valuepointer);
			Source.Profiles[i].WeaponCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Feats");
		Source.Profiles[i].FeatCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].FeatCount, MAX_PROFILE_FEATS, "Profile Feat", "MAX_PROFILE_FEATS");
			Source.Profiles[i].Feats[Source.Profiles[i].FeatCount].Feat = GetFeatNumber(valuepointer);
			Source.Profiles[i].FeatCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Spells");
		Source.Profiles[i].SpellCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].SpellCount, MAX_PROFILE_SPELLS, "Spell Class", "MAX_PROFILE_SPELLS");
			sscanf(valuepointer, "%s %d", tempbuffer, &tempint);
			Source.Profiles[i].Spells[Source.Profiles[i].SpellCount].Spell = GetSpellNumber(tempbuffer);
			Source.Profiles[i].Spells[Source.Profiles[i].SpellCount].MaxNum = tempint;
			Source.Profiles[i].SpellCount++;
			valuepointer += strlen(valuepointer) + 1;
		}
		
		PrepareString(i, "Skills");
		Source.Profiles[i].SkillCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].SkillCount, MAX_PROFILE_SKILLS, "Profile Skills", "MAX_PROFILE_SKILLS");
			sscanf(valuepointer, "%s %d %d", tempbuffer, &tempint, &tempint2);
			Source.Profiles[i].Skills[Source.Profiles[i].SkillCount].Skill = GetSkillNumber(tempbuffer);
			Source.Profiles[i].Skills[Source.Profiles[i].SkillCount].MinLvl = tempint;
			Source.Profiles[i].Skills[Source.Profiles[i].SkillCount].MaxLvl = tempint2;
			mCheckOverflow(Source.Profiles[i].SkillCount, MAX_SKILLS, "Skill Array", "MAX_SKILLS");
			Source.Profiles[i].SkillCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Effects");
		Source.Profiles[i].EffectCount = 0;
		while (*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].EffectCount, MAX_PROFILE_EFFECTS, "Profile Effect", "MAX_PROFILE_EFFECTS");
			Source.Profiles[i].Effects[Source.Profiles[i].EffectCount].Effect = GetEffectNumber(valuepointer);
			Source.Profiles[i].EffectCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Specials");
		Source.Profiles[i].SpecialCount = 0;
		while(*valuepointer != 0)
		{
			mCheckOverflow(Source.Profiles[i].SpecialCount, MAX_PROFILE_SPECIALS, "Profile Special", "MAX_PROFILE_SPECIALS");
			Source.Profiles[i].Specials[Source.Profiles[i].SpecialCount] = GetSpecialNumber(valuepointer);
			Source.Profiles[i].SpecialCount++;
			valuepointer += strlen(valuepointer) + 1;
		}

		PrepareString(i, "Armor");
		sscanf(valuepointer, "%s %d", tempbuffer, &tempint);
		Source.Profiles[i].Armor = GetEquipNumber(tempbuffer);
		Source.Profiles[i].ArmorType = tempint;

		PrepareString(i, "Race");
		Source.Profiles[i].Race = GetRaceNumber(valuepointer);

		PrepareString(i, "MinLevel");
		Source.Profiles[i].MinLevel = atoi(valuepointer);

		PrepareString(i, "Shield");
		sscanf(valuepointer, "%s %d %d", tempbuffer, &tempint, &tempint2);
		Source.Profiles[i].Shield = GetEquipNumber(tempbuffer);
		Source.Profiles[i].ShieldUse[0] = tempint;
		Source.Profiles[i].ShieldUse[1] = tempint2;

		PrepareString(i, "PreferedSchool");
		Source.Profiles[i].PreferedSchool = GetSchoolNumber(valuepointer);

		PrepareString(i, "Attributes");
		sscanf(valuepointer, "%d %d %d %d %d %d", &Source.Profiles[i].AttributePriority[0], &Source.Profiles[i].AttributePriority[1], &Source.Profiles[i].AttributePriority[2], &Source.Profiles[i].AttributePriority[3], &Source.Profiles[i].AttributePriority[4], &Source.Profiles[i].AttributePriority[5]);

	}

	return(0);
}

void ProfileSourceExit()
{
	delete[] Source.Profiles;
}
