int DebugSpare = 0;

#include "scriptvar.h"
#include "scriptvalset.h"

int EvalExpr(clsScriptContext* pContext, unsigned char* script)
{
	int ArgOld, progress;
	size_t EvalVal;

	qprinta(2)(" Evaluating:");
	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	if (pContext->Args[ArgOld + 1].val == '+')
	{
		EvalVal = pContext->Args[ArgOld].val + pContext->Args[ArgOld + 2].val;
	}
	else if (pContext->Args[ArgOld + 1].val == '-')
	{
		EvalVal = pContext->Args[ArgOld].val - pContext->Args[ArgOld + 2].val;
	}
	else if (pContext->Args[ArgOld + 1].val == '*')
	{
		EvalVal = pContext->Args[ArgOld].val * pContext->Args[ArgOld + 2].val;
	}
	else if (pContext->Args[ArgOld + 1].val == '/')
	{
		EvalVal = pContext->Args[ArgOld].val / pContext->Args[ArgOld + 2].val;
	}
	else if (pContext->Args[ArgOld + 1].val == '%')
	{
		EvalVal = pContext->Args[ArgOld].val % pContext->Args[ArgOld + 2].val;
	}

	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = EvalVal;
	pContext->ArgCount++;

	qprinta(2)(" Evaluation Returned %d:", EvalVal);

	return(progress);
}

inline int EvalMaxMin(clsScriptContext* pContext, unsigned char* script, int Max)
{
	int ArgOld, progress;
	size_t EvalVal;

	qprinta(2)(" Max Function:");

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	if (Max)
	{
		EvalVal = max(pContext->Args[ArgOld].val, pContext->Args[ArgOld + 1].val);
	}
	else
	{
		EvalVal = min(pContext->Args[ArgOld].val, pContext->Args[ArgOld + 1].val);
	}

	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = EvalVal;
	pContext->ArgCount++;

	qprinta(2)(" Max/Min Returned %d:", EvalVal);

	return(progress);
}

int EvalMax(clsScriptContext* pContext, unsigned char* script)
{
	return(EvalMaxMin(pContext, script, 1));
}

int EvalMin(clsScriptContext* pContext, unsigned char* script)
{
	return(EvalMaxMin(pContext, script, 0));
}

void LockCharToInt(clsScriptContext* pContext, int nArg)
{
	int converttemp;

	if (pContext->Args[nArg].type == 1)
	{
		converttemp = atoi((char*) pContext->Args[nArg].val);
		pContext->Args[nArg].val = converttemp;
		pContext->Args[nArg].type = 0;
	}
}

int condition_types(clsScriptContext* pContext, unsigned char* script)
{
	int progress;
	progress = ParseScript(pContext, script, 1);

	if(*script == 1 && *(script + 5) == 1 && strcmp(Source.lpSymbolStart + *((int*) (script + 6)), "condition_inverse") == 0)
	{
		pContext->Args[pContext->ArgCount - 1].val = !pContext->Args[pContext->ArgCount - 1].val;
	}

	return(progress);
}

int condition_all(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	if (pContext->ArgCount == ArgOld + 3)
	{
		if (pContext->Args[ArgOld + 1].val == '&')
		{
			pContext->Args[ArgOld].val = pContext->Args[ArgOld].val && pContext->Args[ArgOld + 2].val;
		}
		else if (pContext->Args[ArgOld + 1].val == '|')
		{
			pContext->Args[ArgOld].val = pContext->Args[ArgOld].val || pContext->Args[ArgOld + 2].val;
		}
		else
		{
			qprintf("Fatal Scripting Error\n");
			qon_quitprog();
		}
		pContext->ArgCount = ArgOld + 1;
	}

	return(progress);
}

int condition(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int Result;
	int comparetype;

	bool ConvertToInt = false;

	qprinta(2)(" Checking condition:");

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	comparetype = TwoCharToInt((char*) pContext->Args[ArgOld + 1].val, true);

	if (comparetype != TwoCharToInt("==") && comparetype != TwoCharToInt("!="))
	{
		ConvertToInt = true;
	}
	if (pContext->Args[ArgOld].type == 0 || pContext->Args[ArgOld + 2].type == 0)
	{
		ConvertToInt = true;
	}

	if (ConvertToInt)
	{
		LockCharToInt(pContext, ArgOld);
		LockCharToInt(pContext, ArgOld + 2);
	}

	if (comparetype == TwoCharToInt("==") || comparetype == TwoCharToInt("!="))
	{
		if (pContext->Args[ArgOld].type == 0)
		{
			Result = (pContext->Args[ArgOld].val == pContext->Args[ArgOld + 2].val);
		}
		else
		{
			Result = (strcmp((const char*) pContext->Args[ArgOld].val, (const char*) pContext->Args[ArgOld + 2].val) == 0);
		}
		if (comparetype == TwoCharToInt("!="))
		{
			Result ^= 1;
		}
	}
	else if (comparetype == TwoCharToInt("<="))
	{
		Result = (pContext->Args[ArgOld].val <= pContext->Args[ArgOld + 2].val);
	}
	else if (comparetype == TwoCharToInt(">="))
	{
		Result = (pContext->Args[ArgOld].val >= pContext->Args[ArgOld + 2].val);
	}
	else if (comparetype == '<')
	{
		Result = (pContext->Args[ArgOld].val < pContext->Args[ArgOld + 2].val);
	}
	else if (comparetype == '>')
	{
		Result = (pContext->Args[ArgOld].val > pContext->Args[ArgOld + 2].val);
	}
	
	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = Result;
	pContext->ArgCount++;
	
	return(progress);
}

int sIf(clsScriptContext* pContext, unsigned char* script)
{
	int ArgOld, progress;

	qprinta(2)(" Doing If conditional Order:");

	if (pContext->sIfStack == 255)
	{
		qprintf("Fatal Error\nIf Stack exceeded\n");
		qon_quitprog();//true, pContext->pCurChar->CreationTemplate);
	}

	mCheckOverflow(pContext->sIfStack, MAX_IFSTACK, "IF Stack", "MAX_IFSTACK");
	pContext->sIfStack++;
	pContext->sIfDone[pContext->sIfStack] = 0;

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	pContext->sIfStack--;

	pContext->ArgCount = ArgOld;

	qprinta(2)(" If conditional Order ended:");

	return(progress);
}

int sWhile(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;

	qprinta(2)(" Doing While Order:");

	mCheckOverflow(pContext->sIfStack, MAX_IFSTACK - 1, "IF Stack", "MAX_IFSTACK");

	ArgOld = pContext->ArgCount;

	pContext->sIfStack++;
	pContext->sIfApplied[pContext->sIfStack] = 1;

	while (pContext->sIfApplied[pContext->sIfStack])
	{
		pContext->sIfApplied[pContext->sIfStack] = 0;
		pContext->sIfDone[pContext->sIfStack] = 0;
		progress = ParseScript(pContext, script, 1);
	}
	
	pContext->sIfStack--;
	pContext->ArgCount = ArgOld;

	qprinta(2)(" While Order ended:");

	return(progress);
}

int SkipScript(unsigned char* script, int num)
{
	int i = 0;

	do
	{
		if (script[i] == 0)
		{
			num--;
			i++;
		}
		else if (script[i] == 1)
		{
			num++;
			i += 5;
		}
		else if (script[i] == 2)
		{
			i += 5;
		}
		else
		{
			while (script[i] >= 10)
			{
				i++;
			}
		}
	}
	while (num);

	return(i);
}

inline int sIfa(clsScriptContext* pContext, unsigned char* script, int condition)
{
	int ArgOld, progress, tmpProgress;
	size_t DoThis;

	ArgOld = pContext->ArgCount;

	qprinta(2)(" If block found:");

	if (pContext->sIfDone[pContext->sIfStack])
	{
		qprinta(2)(" Skipping block:");
		progress = SkipScript(script);
	}
	else
	{
		//progress = ParseScript(pContext, script);
		if (condition)
		{
			qprinta(2)(" Checking condition:");
			progress = ParseScript(pContext, script);
			DoThis = pContext->Args[pContext->ArgCount - 1].val;
		}
		else
		{
			qprinta(2)(" No condition (Else block):");
			DoThis = 1;
			progress = 0;
		}
		pContext->ArgCount = ArgOld;

		if (DoThis)
		{
			qprinta(2)(" Performing block:");
			pContext->sIfDone[pContext->sIfStack] = 1;
			tmpProgress = ParseScript(pContext, script + progress);
			if (tmpProgress == 1)
			{
				progress++;
			}
			else
			{
				progress += tmpProgress;
				progress += SkipScript(script + progress);
			}
			//progress += ParseScript(pContext, script + progress);
			
			pContext->sIfApplied[pContext->sIfStack] = 1;
		}
		else
		{
			qprinta(2)(" Condition did not aply:");
			progress += SkipScript(script + progress);
			pContext->sIfApplied[pContext->sIfStack] = 0;
		}
	}

	qprinta(2)(" If block ended:");

	pContext->ArgCount = ArgOld;
	return(progress);
}

int sIfa_i(clsScriptContext* pContext, unsigned char* script)
{
	return(sIfa(pContext, script, 1));
}

int sIfa_e(clsScriptContext* pContext, unsigned char* script)
{
	return(sIfa(pContext, script, 0));
}

int sFor(clsScriptContext* pContext, unsigned char* script)
{
	int progress, ArgOld;
	int pos_condition, pos_increment, pos_order;
	int loopok;

	ArgOld = pContext->ArgCount;

	//progress = ParseScript(pContext, script); //"for("
	progress = ParseScript(pContext, script); //valset
	//progress += ParseScript(pContext, script + progress); //";"

	pos_condition = progress;
	progress += SkipScript(script + progress, 0); //condition

	//progress += ParseScript(pContext, script + progress); //";"

	pos_increment = progress;
	progress += SkipScript(script + progress, 0); //increment

	//progress += ParseScript(pContext, script + progress); //"){"

	pos_order = progress;

	do
	{
		ParseScript(pContext, script + pos_condition);
		pContext->ArgCount--;
		if (pContext->Args[pContext->ArgCount].val == 1)
		{
			progress = ParseScript(pContext, script + pos_order);
			ParseScript(pContext, script + pos_increment);
			loopok = 1;
		}
		else
		{
			progress += pos_order + (progress == 1 ? 0 : SkipScript(script + pos_order + progress));
			loopok = 0;
		}
	} while (loopok);

	pContext->ArgCount = ArgOld;
	return(progress);
}

#include "scriptextract.h"
#include "scriptredir2.h"

int ParseScript(clsScriptContext* pContext, unsigned char* script, int depth, char* pThisSymbol)
{
	int i;
	char* pSymbol;
	char DebugTemp[8];

	DebugSpare++;

	i = 0;
	do
	{
		if (script[i] == 0)
		{
			i++;
			depth--;
		}
		else if (script[i] == 1)
		{
			i++;
			pSymbol = (char*) Source.lpSymbolStart + *((int*) &script[i]);
			i += sizeof(int);

			if (qon_DebugOutput || logverbose >= 2)
			{
				sprintf(DebugTemp, "%%%ds", DebugSpare * 2);
				qprinta(2)("\n");
				qprinta(2)(DebugTemp, "");
				qprinta(2)("%4d - %s:", (int) (size_t) (&script[i] - pContext->lpCodeStart - 5), pSymbol);
			}

			if (*((int*) (pContext->RedirFuncs + *((int*) &script[i - sizeof(int)]))))
			{
				i += ((int(*)(clsScriptContext*, unsigned char*)) *((size_t*) (pContext->RedirFuncs + *((int*) &script[i - sizeof(int)]))))(pContext, &script[i]);

			}
			else
			{
				i += ParseScript(pContext, &script[i], 1, pSymbol);
			}
		}
		else if (script[i] == 2)
		{
			i += 5;
			qprinta(2)("%d", *(int*)(&script[i-4]));
		}
		else
		{
			char CharOut[2] = " ";
			while (script[i] >= 10)
			{
				CharOut[0] = script[i];
				qprinta(2)("%s", CharOut);
				i++;
			}
		}
	} while (depth > 0);

	if (*pThisSymbol && *((int*) (pContext->RedirExtract + (pThisSymbol - Source.lpSymbolStart))))
	{
		((int(*)(clsScriptContext*, size_t)) *((size_t*) (pContext->RedirExtract + (pThisSymbol - Source.lpSymbolStart))))(pContext, (size_t) script);
	}

	DebugSpare--;

	return(i);
}
