#ifdef STRING_INCLUDE_IN_CLASS
	char* operator =(char* pStr)
	{
		//printf("= char*\n");
		savefree();
		len = strlen(pStr);
		buffer = savealloc(len + 1);
		CopyMemory(buffer, pStr, len + 1);

		return(buffer);
	}

	char* operator =(const char* pStr)
	{
		//printf("= char*\n");
		savefree();
		len = strlen(pStr);
		buffer = savealloc(len + 1);
		CopyMemory(buffer, pStr, len + 1);

		return(buffer);
	}

	char* operator =(const STRING_INCLUDE_TYPE& strStr)
	{
		//printf("= string\n");
		savefree();
		if (len = strStr.len)
		{
			buffer = savealloc(len + 1);
			CopyMemory(buffer, strStr.buffer, len + 1);
		}
		else
		{
			buffer = EmptyString;
		}
		return(buffer);
	}

	char* operator +=(const STRING_INCLUDE_TYPE& strStr)
	{
		if (strStr.len)
		{
			buffer = saverealloc(buffer, len + strStr.len + 1);
			CopyMemory(buffer + len, strStr.buffer, strStr.len + 1);
			len += strStr.len;
		}
		return(buffer);
	}

	char* operator +=(const char* pStr)
	{
		const size_t tmpLen = strlen(pStr);
		if (tmpLen)
		{
			buffer = saverealloc(buffer, len + tmpLen + 1);
			CopyMemory(buffer + len, pStr, tmpLen + 1);
			len += tmpLen;
		}
		return(buffer);
	}

	int operator ==(const char* pStr)
	{
		//printf("== char*\n");
		return(strlen(pStr) == len && strcmp(buffer, pStr) == 0);
	}

	int operator ==(char* pStr)
	{
		return(strlen(pStr) == len && strcmp(buffer, pStr) == 0);
	}

	int operator ==(const STRING_INCLUDE_TYPE& strStr)
	{
		//printf("== string\n");
		return(len == strStr.len && strncmp(buffer, strStr.buffer, len) == 0);
	}

	template <class T>int operator !=(T pStr)
	{
		//printf("!=\n");
		return(!(*this == pStr));
	}

	friend size_t strlen(const STRING_INCLUDE_TYPE& strStr);
	friend inline char* strcat(char* pStr, const STRING_INCLUDE_TYPE& strStrCat);
	friend inline char* strcpy(char* pStr, const STRING_INCLUDE_TYPE& strStrCpy);
	friend inline void ucase(STRING_INCLUDE_TYPE& strStr);

	friend inline void strcut(STRING_INCLUDE_TYPE& strStr, size_t NewLen);

	operator const char*() const
	{
		return(buffer);
	}
#endif



#ifdef STRING_INCLUDE_AFTTER_CLASS
extern inline size_t strlen(const STRING_INCLUDE_TYPE& strStr);

template <class T> extern inline char* strcat(STRING_INCLUDE_TYPE& strStr, const T& pStrCat);
extern inline char* strcat(char* pStr, const STRING_INCLUDE_TYPE& strStrCat);
template <class T> extern inline char* strcpy(STRING_INCLUDE_TYPE& strStr, const T& pStrCpy);
extern inline char* strcpy(char* pStr, const STRING_INCLUDE_TYPE& strStrCpy);

#ifndef GCC_RUNTIME
#ifndef VSNET_RUNTIME
#ifndef VECTORC_RUNTIME

template <class T> extern inline int strcmp(const STRING_INCLUDE_TYPE& strStr, const T& pStrCmp);
extern inline int strcmp(const char* pStr, STRING_INCLUDE_TYPE& strStrCmp);

#endif
#endif
#endif

extern inline char* strstr(const STRING_INCLUDE_TYPE& strStr, const STRING_INCLUDE_TYPE& strStrstr);
extern inline char* strstr(const STRING_INCLUDE_TYPE& strStr, const char* pStrstr);
extern inline char* strstr(const char* pStr, const STRING_INCLUDE_TYPE& strStrstr);

extern inline void ucase(STRING_INCLUDE_TYPE& strStr);

extern inline void strcut(STRING_INCLUDE_TYPE& strStr, size_t NewLen);
#endif



#ifdef STRING_INCLUDE_CPP

inline size_t strlen(const STRING_INCLUDE_TYPE& strStr)
{
	//printf("strlen\n");
	return(strStr.len);
}

template <class T>inline char* strcat(STRING_INCLUDE_TYPE& strStr, const T& pStrCat)
{
	//printf("strcat(string, T)\n");
	return(strStr += pStrCat);
}

template <class T>inline char* strcat(STRING_INCLUDE_TYPE& strStr, T& pStrCat)
{
	//printf("strcat(string, T)\n");
	return(strStr += pStrCat);
}

inline char* strcat(char* pStr, const STRING_INCLUDE_TYPE& strStrCat)
{
	//printf("strcat(char*, string)\n");
	CopyMemory(pStr + strlen(pStr), strStrCat.buffer, strStrCat.len + 1);
	return(strStrCat.buffer);
}

template <class T>inline char* strcpy(STRING_INCLUDE_TYPE& strStr, const T& pStrCpy)
{
	//printf("strcpy(string, T)\n");
	return(strStr = pStrCpy);
}

inline char* strcpy(char* pStr, const STRING_INCLUDE_TYPE& strStrCpy)
{
	//printf("strcpy(char*, string\n");
	CopyMemory(pStr, strStrCpy.buffer, strStrCpy.len + 1);
	return(strStrCpy.buffer);
}

#ifndef VECTORC_RUNTIME
#ifndef GCC_RUNTIME
#ifndef VSNET_RUNTIME

template <class T>inline int strcmp(const STRING_INCLUDE_TYPE& strStr, const T& pStrCmp)
{
	//printf("strcmp(string, T\n");
	return(!(strStr == pStrCmp));
}

inline int strcmp(const char* pStr, STRING_INCLUDE_TYPE& strStrCmp)
{
	//printf("strcmp(char*, string)\n");
	return(!(strStrCmp == pStr));
}

#endif
#endif
#endif

inline char* strstr(const STRING_INCLUDE_TYPE& strStr, const STRING_INCLUDE_TYPE& strStrstr)
{
	//printf("strcmp(string, string)\n");
	return(strstr(strStr.buffer, strStrstr.buffer));
}

inline char* strstr(const STRING_INCLUDE_TYPE& strStr, const char* pStrstr)
{
	//printf("strcmp(string, string)\n");
	return(strstr(strStr.buffer, pStrstr));
}

inline char* strstr(const char* pStr, const STRING_INCLUDE_TYPE& strStrstr)
{
	//printf("strcmp(string, string)\n");
	return(strstr((char*) pStr, (const char*) strStrstr.buffer));
}

inline void ucase(STRING_INCLUDE_TYPE& strStr)
{
	for (unsigned int i = 0;i < strStr.len;i++)
	{
		if (strStr.buffer[i] >= 'a' && strStr.buffer[i] <= 'z')
		{
			strStr.buffer[i] &= ~32;
		}
	}
}

inline void strcut(STRING_INCLUDE_TYPE& strStr, size_t NewLen)
{
	if (NewLen < strStr.len)
	{
		strStr.buffer[NewLen] = 0;
		strStr.buffer = strStr.saverealloc(strStr.buffer, NewLen + 1);
		strStr.len = NewLen;
	}
}

#endif
